precision highp float;

#define SOFTLIGHT(base, overlay) (overlay < 0.5) ? 2.0 * base * overlay + base * base * (1.0 - 2.0 * overlay) : sqrt(base) * (2.0 * overlay - 1.0) + 2.0 * base * (1.0 - overlay)
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float opacity;
void main()
{
    vec4 base = texture2D(inputImageTexture, textureCoordinate);
    vec4 overlay = texture2D(inputImageTexture2, textureCoordinate2);
    gl_FragColor = vec4(mix(base.rgb, vec3(SOFTLIGHT(base.r, overlay.r), SOFTLIGHT(base.g, overlay.g), SOFTLIGHT(base.b, overlay.b)), overlay.a * opacity), base.a);
}