//磨砂效果-需要与模糊滤镜组合使用
precision highp float;
//original texture
uniform sampler2D inputImageTexture;
//blur texture
uniform sampler2D inputImageTexture2;
varying vec2 textureCoordinate;
//纹理尺寸大小
uniform vec2 iResolution;
//圆形大小0-1
uniform float size;
//x偏移值,默认0.5,范围0-1
uniform float xOffset;
//y偏移值,默认0.5,范围0-1
uniform float yOffset;

void main() {
    vec2 newuv = textureCoordinate-vec2(xOffset, yOffset);
    if (iResolution.x>iResolution.y) {
        newuv.x*=iResolution.x/iResolution.y;
    } else {
        newuv.y*=iResolution.y/iResolution.x;
    }
    float dis=smoothstep(size, size+0.2, length(newuv));

    vec4 origin = texture2D(inputImageTexture, textureCoordinate);
    vec4 blured = texture2D(inputImageTexture2, textureCoordinate);

    float blurDis=mix(0.4, 1.0, dis);
    vec4 result = vec4(0.0, 0.0, 0.0, origin.a);
    result.rgb=mix(origin.rgb, blured.rgb, blurDis);

    gl_FragColor = result;
    gl_FragColor.a = origin.a;
}