precision highp float;
varying vec2 textureCoordinate;
varying vec2 textureCoordinate2;
//输入纹理
uniform sampler2D inputImageTexture;
//lut
//uniform sampler2D inputImageTexture2;
//noise
uniform sampler2D inputImageTexture2;
//blur
uniform sampler2D inputImageTexture3;


float screen(float base, float blend) {
    return base + blend - base * blend;
}

lowp vec4 screen(lowp vec4 base, lowp vec4 blend) {
    return base + blend - base * blend;
}

vec4 screen(vec4 base, vec4 blend, float opacity) {
    return mix(base, screen(base, blend), opacity);
}

float blendOverlay(float base, float blend) {
    return base<0.5?(2.0*base*blend):(1.0-2.0*(1.0-base)*(1.0-blend));
}

vec3 blendOverlay(vec3 base, vec3 blend) {
    return vec3(blendOverlay(base.r, blend.r), blendOverlay(base.g, blend.g), blendOverlay(base.b, blend.b));
}

vec3 blendHardLight(vec3 base, vec3 blend) {
    return blendOverlay(blend, base);
}

vec3 blendHardLight(vec3 base, vec3 blend, float opacity) {
    return (blendHardLight(base, blend) * opacity + base * (1.0 - opacity));
}

void main() {
    vec4 source = texture2D(inputImageTexture, textureCoordinate);
    vec4 blur = texture2D(inputImageTexture3, textureCoordinate);//getPin1(textureCoordinate);
    vec4 noise = texture2D(inputImageTexture2, textureCoordinate2);//getPin3Clamp(mod(textureCoordinate2, 1.f));

    //mix
    float blue = pow(blur.b, 0.65);

    vec4 result = vec4(source.r, source.g, screen(source.b, blue), source.a);

    //noise
    float l = result.r*0.30+result.g*0.59+result.b*0.11;
    const float _in = 0.2;
    const float _out = 0.8;
    float alphaWeight = mix(0.35, 0.1, clamp((l - _in)/(_out-_in), 0.0, 1.0));

    result = vec4(blendHardLight(result.rgb, noise.rgb, alphaWeight), result.a);

    //lut
    //    float blueChannel = result.b * 63.0;
    //
    //    vec2 quad1;
    //    quad1.y = floor(floor(blueChannel) / 8.0);
    //    quad1.x = floor(blueChannel) - (quad1.y * 8.0);
    //
    //    vec2 quad2;
    //    quad2.y = floor(ceil(blueChannel) / 8.0);
    //    quad2.x = ceil(blueChannel) - (quad2.y * 8.0);
    //
    //    vec2 texPos1;
    //    texPos1.x = (quad1.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * result.r);
    //    texPos1.y = (quad1.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * result.g);
    //
    //    vec2 texPos2;
    //    texPos2.x = (quad2.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * result.r);
    //    texPos2.y = (quad2.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * result.g);
    //
    //    texPos1.y = 1. - texPos1.y;
    //    texPos2.y = 1. - texPos2.y;
    //
    //    lowp vec4 lutColor1 = texture2D(inputImageTexture2, textureCoordinate);//getPin2(texPos1);
    //    lowp vec4 lutColor2 = texture2D(inputImageTexture2, textureCoordinate);//getPin2(texPos2);
    //
    //    lowp vec4 lutColor = mix(lutColor1, lutColor2, fract(blueChannel));
    //
    //    gl_FragColor = mix(result, vec4(lutColor.rgb, result.w), 1.0);

    gl_FragColor = result;

}