precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

//滤色强度,默认0.65，0-1
uniform float intensity;

float screen(float base, float blend) {
    return base + blend - base * blend;
}

lowp vec4 screen(lowp vec4 base, lowp vec4 blend) {
    return base + blend - base * blend;
}

vec4 screen(vec4 base, vec4 blend, float opacity) {
    return mix(base, screen(base, blend), opacity);
}


void main() {
    lowp vec4 src = texture2D(inputImageTexture, textureCoordinate);
    lowp vec4 blurColor = texture2D(inputImageTexture2, textureCoordinate);
    gl_FragColor = screen(src, blurColor, intensity);
}
