precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
varying vec2 imageRectUv;
varying vec2 imageMaskUv;

lowp vec4 normal(lowp vec4 base, lowp vec4 blend) {
    return vec4(base.rgb * (1.0 - blend.a) + blend.rgb, base.a + blend.a - base.a * blend.a);
}

lowp vec4 normal(lowp vec4 base, lowp vec4 blend, float opacity) {
    return normal(base, blend * opacity);
}

vec4 getPin0(vec2 uv) {
    return texture2D(inputImageTexture, uv);
}
vec4 getPin1(vec2 uv) {
    return texture2D(inputImageTexture2, uv);
}

vec4 getPin0Masked(vec2 uv, vec2 mask) {
    lowp vec2 s = step(vec2(0.), mask) - step(vec2(1.), mask);
    return getPin0(uv) * s.x * s.y;
}

void main() {

    vec4 result = vec4(0., 0., 0., 1.);
    vec4 image = getPin0Masked(imageRectUv, imageMaskUv);
    vec4 border = getPin1(imageMaskUv);
    result = normal(result, image * (1. - border.r));
    gl_FragColor = result;
}