precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

varying vec2 picutreCoordinate;
varying vec2 borderCoordinate;

vec4 getTexture0(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

vec4 getTexture1(vec2 uv){
    return texture2D(inputImageTexture2, uv);
}

vec4 getTexture1Clamp(vec2 uv) {
    return getTexture1(clamp(uv, 0.001, 0.999));
}

void main() {
    lowp vec4 result = getTexture0(picutreCoordinate);

    highp vec4 text = getTexture1Clamp(borderCoordinate);
    result = mix(result, text, text.a);
    gl_FragColor = result;
}
