precision highp float;

varying vec2 textureCoordinate;
//图片纹理
uniform sampler2D inputImageTexture;
//噪点纹理
uniform sampler2D inputImageTexture2;

varying highp vec2 noiseUv;
//柔光强度,默认0.7，0-1
uniform float intensity;

lowp float softLight(lowp float base, lowp float blend) {
    return (blend<0.5)?(2.0*base*blend+base*base*(1.0-2.0*blend)):(sqrt(base)*(2.0*blend-1.0)+2.0*base*(1.0-blend));
}

lowp vec4 softLight(lowp vec4 base, lowp vec4 blend) {
    return vec4(
    softLight(base.r, blend.r),
    softLight(base.g, blend.g),
    softLight(base.b, blend.b),
    base.a + blend.a - base.a * blend.a
    );
}

vec4 softLight(vec4 base, vec4 blend, float opacity) {
    return mix(base, softLight(base, blend), opacity);
}


void main() {
    lowp vec4 src = texture2D(inputImageTexture, textureCoordinate);
    lowp vec4 noiseColor = texture2D(inputImageTexture2, noiseUv);
    gl_FragColor = softLight(src, noiseColor, intensity);
}
