precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float inIntensity;
uniform float outIntensity;

void main()
{
    vec4 result = texture2D(inputImageTexture, textureCoordinate);

    float alphaWeight = clamp((result.b - inIntensity)/(outIntensity-inIntensity), 0., 1.);

    gl_FragColor = vec4(result.b * alphaWeight);
}