precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
//强度,默认0.08
uniform float intensity;

vec4 getTexture0(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

vec4 rgbShift(highp vec2 uv, highp float strength) {
    vec3 refractiveIndex = vec3(0.999, 0.985 + (1. - strength) * 0.014,
    0.97 + (1. - strength) * 0.029);
    vec2 normalizedTexCoord = vec2(2.0, 2.0) * uv - vec2(1.0, 1.0);
    vec3 texVec = vec3(normalizedTexCoord, 1.0);
    vec3 normalVec = vec3(0.0, 0.0, -1.0);
    vec3 redRefractionVec = refract(texVec, normalVec, refractiveIndex.r);
    vec3 greenRefractionVec = refract(texVec, normalVec, refractiveIndex.g);
    vec3 blueRefractionVec = refract(texVec, normalVec, refractiveIndex.b);
    vec2 redTexCoord =
    ((redRefractionVec / redRefractionVec.z).xy + vec2(1.0, 1.0)) /
    vec2(2.0, 2.0);
    vec2 greenTexCoord =
    ((greenRefractionVec / greenRefractionVec.z).xy + vec2(1.0, 1.0)) /
    vec2(2.0, 2.0);
    vec2 blueTexCoord =
    ((blueRefractionVec / blueRefractionVec.z).xy + vec2(1.0, 1.0)) /
    vec2(2.0, 2.0);

    return vec4(getTexture0(redTexCoord).r,
    getTexture0(greenTexCoord).g,
    getTexture0(blueTexCoord).b, 1.0);
}

void main() {
    //第二个参数是强度
    vec4 result = rgbShift(textureCoordinate, intensity);
    gl_FragColor = result;
}
