precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

//const int blurStep = 3;
//const float ANGLE = 0.6 / 180.0 * 3.141593;

uniform int blurStep;
uniform float angle;


vec4 getPin0(vec2 uv){
    return texture2D(inputImageTexture, uv);
}

vec2 rotate(vec2 uv, vec2 p, float angle){
    mat2 rotation = mat2(vec2(cos(angle), -sin(angle)),
    vec2(sin(angle), cos(angle)));
    uv -= p;
    uv = uv * rotation;
    uv += p;
    return uv;
}

void main(){
    float ANGLE = angle / 180.0 * 3.141593;
    float perAngle = ANGLE  / float(blurStep);
    vec2 uv = textureCoordinate.xy;

    vec4 totalColor = vec4(0.0);
    float ws = 0.0;

    for (int i = 0; i < blurStep * 2 + 1; i++){
        float rotation =  -ANGLE  + float(i) * perAngle;
        float w = 1.0;

        totalColor += getPin0(rotate(uv, vec2(0.5, 0.5), rotation)) * w;
        ws += w;
    }

    gl_FragColor = totalColor.rgba / ws;
}