precision highp float;

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

//vec2 textureSize = vec2(600.0,800.0);
//vec2 grainTextureSize = vec2(1024.0,1024.0);
//float textureScale = 1.0;
//
//float grain_highlights = 0.13;
//float grain_amount = 0.05;
//float grain_size = 0.05;
//float grain_roughness = 10.0;

uniform vec2 textureSize;
vec2 grainTextureSize = vec2(1024.0, 1024.0);
uniform float textureScale;
uniform float grain_highlights;
uniform float grain_amount;
uniform float grain_size;
uniform float grain_roughness;

float o(vec3 inputRGB){
    const vec3 b=vec3(.298839, .586811, .11435);
    return dot(inputRGB, b);
}

vec2 P(vec2 a){
    float b=sin(dot(a, vec2(12.9898, 78.233)))*43758.5453;
    return fract(vec2(1.3453, 1.3647)*b)*2.-1.;
}

vec3 N(vec3 b){
    const vec4 d=vec4(0., -1./3., 2./3., -1.);
    vec4 c = vec4(b.gb, d.xy);
    if (b.g<b.b){
        c = vec4(b.bg, d.wz);
    }
    vec4 a = vec4(b.r, c.yzx);
    if (b.r<c.x){
        a = vec4(c.xyw, b.r);
    }
    float e=a.x-min(a.w, a.y);
    return vec3(abs(a.z+(a.w-a.y)/(6.*e+1e-10)), e/(a.x+1e-10), a.x);
}

vec3 F(vec3 b){
    const vec4 a=vec4(1., 2./3., 1./3., 3.);
    vec3 c=abs(fract(b.xxx+a.xyz)*6.-a.www);
    return b.z*mix(a.xxx, clamp(c-a.xxx, 0., 1.), b.y);
}

vec3 E(vec3 b, vec3 c){
    vec3 a = N(b);
    vec3 d = N(c);
    a.x = d.x;
    return clamp(F(a), 0., 1.);
}

vec3 blur(vec3 c, float i, float e, vec2 textureCoordinate){
    vec2 realSize = 1. / textureSize * textureScale;
    vec2 fixedValue = realSize * e * 2. - i * realSize;
    vec2 h = P(textureCoordinate) * realSize * e;
    vec2 d = (0. + h) * fixedValue;
    vec2 a = (1. + h) * fixedValue;
    vec2 b = (2. + h) * fixedValue;
    vec3 j = c;
    c= .013514*texture2D(inputImageTexture, textureCoordinate.xy+vec2(-b.x, -b.y)).rgb+.027027*texture2D(inputImageTexture, textureCoordinate.xy+vec2(-b.x, -a.y)).rgb
    +.040541*texture2D(inputImageTexture, textureCoordinate.xy+vec2(-b.x, -d.y)).rgb+.027027*texture2D(inputImageTexture, textureCoordinate.xy+vec2(-b.x, +a.y)).rgb
    +.013514*texture2D(inputImageTexture, textureCoordinate.xy+vec2(-b.x, +b.y)).rgb+.027027*texture2D(inputImageTexture, textureCoordinate.xy+vec2(-a.x, -b.y)).rgb
    +.054054*texture2D(inputImageTexture, textureCoordinate.xy+vec2(-a.x, -a.y)).rgb+.067568*texture2D(inputImageTexture, textureCoordinate.xy+vec2(-a.x, -d.y)).rgb
    +.054054*texture2D(inputImageTexture, textureCoordinate.xy+vec2(-a.x, +a.y)).rgb+.027027*texture2D(inputImageTexture, textureCoordinate.xy+vec2(-a.x, +b.y)).rgb
    +.040541*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+d.x, -b.y)).rgb+.067568*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+d.x, -a.y)).rgb
    +.081081*c+.067568*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+d.x, +a.y)).rgb+.040541*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+d.x, +b.y)).rgb
    +.027027*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+a.x, -b.y)).rgb+.054054*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+a.x, -a.y)).rgb
    +.067568*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+a.x, -d.y)).rgb+.054054*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+a.x, +a.y)).rgb
    +.027027*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+a.x, +b.y)).rgb+.013514*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+b.x, -b.y)).rgb
    +.027027*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+b.x, -a.y)).rgb+.040541*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+b.x, -d.y)).rgb
    +.027027*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+b.x, +a.y)).rgb+.013514*texture2D(inputImageTexture, textureCoordinate.xy+vec2(+b.x, +b.y)).rgb;
    c=mix(c, j, (1. + i) * 2. *(1. - e));
    c=clamp(c, 0., 1.);
    c=E(c, j);
    return c;
}

vec3 grain(vec3 inputRGB, float grain_amount, float grain_size, float grain_roughness, vec2 grainTextureSize, sampler2D grainTexture, vec2 uv){
    float l = o(inputRGB);
    float p = grain_amount * (1.0 - grain_highlights);
    float i = mix(grain_amount, p, l);
    vec2 b = uv.xy * textureSize / grainTextureSize;
    //    vec2 newXY = b + P(b).xy / grainTextureSize / textureScale / 3.;
    vec4 c = texture2D(grainTexture, b);
    vec2 g = vec2(mix(c.r / c.a, c.b/ c.a, grain_size), mix(c.g/ c.a, c.a, grain_size));
    float n = mix(g.x, g.y, grain_roughness);
    vec3 j = inputRGB * n * 2.;
    vec3 outputRGB = mix(inputRGB, j, i);
    return outputRGB;
}

void main(){
    vec2 uv = textureCoordinate;
    vec4 c = texture2D(inputImageTexture, uv.xy);
    vec3 a = c.rgb;
    float f=max(0., (grain_size-.25)/.75)*pow(grain_amount, .25);
    vec3 tex = a;
    if (f != 0.){
        tex = blur(a, 0., f, textureCoordinate);
    }
    vec3 gr = grain(tex, grain_amount, grain_size, grain_roughness, grainTextureSize, inputImageTexture2, uv);
    vec3 mr = mix(c.rgb, gr, c.a);
    gl_FragColor = vec4(mr, c.a);
}