int LENGTH = 17;

attribute vec4 position;
uniform mat4 uMVPMatrix;
uniform mat4 uTexMatrix;
attribute vec4 inputTextureCoordinate;
varying vec2 textureCoordinate;
uniform float intensity;
uniform vec2 iResolution;
varying float weights[17];
varying float radius;

void main()
{
    float bySize = intensity * 100.0 *max((iResolution.x / 765.0), 1.0) * 0.04;
    radius = bySize * 3.0;

    float totalExp = 0.0;
    //计算weights
    int min = int(min(float(LENGTH), radius + 1.0));
    for (int i=0;i<min;i++){
        float exp = exp((-(pow(float(i), 2.0))) / (pow(radius/3.0, 2.0) * 2.0));
        weights[i] = exp;
        if (i ==0){
            totalExp = totalExp + exp;
        } else {
            totalExp = totalExp + (exp * 2.0);
        }
    }
    for (int i=0;i<min;i++){
        weights[i] = weights[i] / totalExp;
    }

    //计算radius
    if (radius > float(LENGTH - 1)) {
        radius = float(LENGTH - 1);
    } else {
        radius = radius;
    }

    gl_Position = uMVPMatrix * position;
    textureCoordinate = (uTexMatrix * inputTextureCoordinate).xy;
}