precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec2 iResolution;
varying float radius;
varying float weights[17];

void main() {
    //    if(iResolution.y < 1){
    //        iResolution.y = 1080.;
    //    }
    if (radius < 1.0) {
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    } else {
        float dy = 1.0 / iResolution.y;
        vec4 color = texture2D(inputImageTexture, textureCoordinate) * weights[0];
        for (int i = 1; i <= int(radius); i++) {
            color += texture2D(inputImageTexture, textureCoordinate + vec2(0.0, dy * float(i))) * weights[i];
            color += texture2D(inputImageTexture, textureCoordinate - vec2(0.0, dy * float(i))) * weights[i];
        }
        gl_FragColor = color;
    }
}
