precision lowp float;

#define w1 0.033159047
#define w2 0.054670025
#define w3 0.08065691
#define w4 0.10648267
#define w5 0.12579441
#define w6 0.13298076
#define wS 0.9345069
varying lowp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform lowp vec2 iResolution;
uniform lowp float highlight_intensity;
uniform lowp float blur_intensity;
uniform bool blur_vertical;
vec4 BlurH(sampler2D source, vec2 size, vec2 uv) {
    lowp vec4 A = vec4(0.0);
    lowp vec4 C = vec4(0.0);
    lowp float width = blur_intensity / size.x;
    A = texture2D(source, (uv + vec2(width * -5., 0.0))) * w1
    + texture2D(source, (uv + vec2(width * -4., 0.0))) * w2
    + texture2D(source, (uv + vec2(width * -3., 0.0))) * w3
    + texture2D(source, (uv + vec2(width * -2., 0.0))) * w4
    + texture2D(source, (uv + vec2(width * -1., 0.0))) * w5
    + texture2D(source, (uv)) * w6
    + texture2D(source, (uv + vec2(width * 1., 0.0))) * w5
    + texture2D(source, (uv + vec2(width * 2., 0.0))) * w4
    + texture2D(source, (uv + vec2(width * 3., 0.0))) * w3
    + texture2D(source, (uv + vec2(width * 4., 0.0))) * w2
    + texture2D(source, (uv + vec2(width * 5., 0.0))) * w1;
    A = A / wS;
    return A;
}

vec4 BlurV(sampler2D source, vec2 size, vec2 uv) {
    lowp vec4 A = vec4(0.0);
    lowp vec4 C = vec4(0.0);
    lowp float height = blur_intensity / size.y;
    A = texture2D(source, (uv + vec2(0., height * -5.))) * w1
    + texture2D(source, (uv + vec2(0., height * -4.))) * w2
    + texture2D(source, (uv + vec2(0., height * -3.))) * w3
    + texture2D(source, (uv + vec2(0., height * -2.))) * w4
    + texture2D(source, (uv + vec2(0., height * -1.))) * w5
    + texture2D(source, (uv)) * w6
    + texture2D(source, (uv + vec2(0., height * 1.))) * w5
    + texture2D(source, (uv + vec2(0., height * 2.))) * w4
    + texture2D(source, (uv + vec2(0., height * 3.))) * w3
    + texture2D(source, (uv + vec2(0., height * 4.))) * w2
    + texture2D(source, (uv + vec2(0., height * 5.))) * w1;
    A = A / wS;
    return A;
}

void main() {
    lowp vec4 color = texture2D(inputImageTexture, textureCoordinate);
    lowp float brightness = dot(color.rgb, vec3(0.2126, 0.7152, 0.0722));
    if (brightness > highlight_intensity) {
        if (blur_vertical) {
            gl_FragColor = BlurV(inputImageTexture, iResolution.xy, textureCoordinate);
        } else {
            gl_FragColor = BlurH(inputImageTexture, iResolution.xy, textureCoordinate);
        }
    } else {
        gl_FragColor = color;
    }
}