precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec2 size;
uniform float r;

void main() {
    //    if(size.y < 1){
    //        size.y = 1080.;
    //    }
    float dy = 1. / size.y;
    float dx = 1. / size.x;
    float w = 0.;
    vec4 color = vec4(0., 0., 0., 0.);
    if (r >= 0.004){
        for (int i = int(-3. * r); i < int(3. * r + 1.); i++){
            float w2 = exp(- pow (float(i), 2.) / (2. * pow(r, 2.)));
            color += texture2D(inputImageTexture, textureCoordinate + vec2(dx * float(i), dy * float(i))) * w2;
            w += w2;
        }
    }
    if (w < 1.){
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    } else {
        gl_FragColor =  color / w;
    }
}
