//提取高光
precision highp float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;

//0.83984375
uniform float intensity;

const highp vec3 W = vec3(0.2125, 0.7154, 0.0721);
void main() {
    vec4 color = texture2D(inputImageTexture, textureCoordinate);
    float luminance = dot(color.rgb, W);
    if (luminance > intensity) {
        gl_FragColor = color;
    } else {
        gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
    }
}