precision highp float;
uniform sampler2D inputImageTexture;
uniform float intensity;

const lowp int GAUSSIAN_SAMPLES = 4;

varying vec2 textureCoordinate;
varying vec2 blurCoordinates[GAUSSIAN_SAMPLES];
const float factor = 1.0/float(GAUSSIAN_SAMPLES);

void main()
{
    lowp vec3 sum = vec3(0.0);
    for (int i=0; i<GAUSSIAN_SAMPLES; i++) {
        sum += texture2D(inputImageTexture, blurCoordinates[i]).rgb;
    }
    //gl_FragColor = vec4(sum* factor, 1.0);
    vec3 average = sum* factor;
    float brightness = dot(average, vec3(0.2126, 0.7152, 0.0722));
    if (brightness > intensity) {
        gl_FragColor = vec4(brightness, brightness, brightness, 1.0);
    } else {
        gl_FragColor = vec4(0.0);
    }
}