precision highp float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;
vec2 mouseFocusPoint = vec2(0.5, 0.5);
uniform float intensity;
void main() {
    float redOffset   =  0.004;
    float greenOffset =  0.001;
    float blueOffset  = -0.002;

    //vec2 texSize  = textureSize(colorTexture, 0).xy;
    //vec2 texCoord = gl_FragCoord.xy / texSize;

    vec2 direction = textureCoordinate - mouseFocusPoint;
    float r = length(direction);
    float r2 = r/85.0;
    float r3 = 0.0;
    if(r>0.4) {
        r3 = (r-0.4)*6.5 *0.65;
    }

    vec4 color;
    color.a = 1.0;
    color.r = texture2D(inputImageTexture, textureCoordinate - (direction * vec2(r2)) + ((1.0+r3)*direction * vec2(redOffset))).r;
    color.g = texture2D(inputImageTexture, textureCoordinate - (direction * vec2(r2)) + ((1.0+r3)*direction * vec2(greenOffset))).g;
    color.b = texture2D(inputImageTexture, textureCoordinate - (direction * vec2(r2)) + ((1.0+r3)*direction * vec2(blueOffset))).b;
    //vec4 color = texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor = color;
}