precision highp float;
uniform sampler2D inputImageTexture;

const lowp int GAUSSIAN_SAMPLES = 5;
uniform float weight[GAUSSIAN_SAMPLES];

varying vec2 textureCoordinate;
varying vec2 blurCoordinates[GAUSSIAN_SAMPLES];

void main()
{
    lowp vec3 sum = vec3(0.0);
    sum += texture2D(inputImageTexture, blurCoordinates[0]).rgb * weight[0];
    sum += texture2D(inputImageTexture, blurCoordinates[1]).rgb * weight[1];
    sum += texture2D(inputImageTexture, blurCoordinates[2]).rgb * weight[2];
    sum += texture2D(inputImageTexture, blurCoordinates[3]).rgb * weight[3];
    sum += texture2D(inputImageTexture, blurCoordinates[4]).rgb * weight[4];
    gl_FragColor = vec4(sum, 1.0);
}