precision highp float;
attribute vec4 position;
attribute vec4 inputTextureCoordinate;

const int GAUSSIAN_SAMPLES = 4;

uniform float texelWidthOffset;
uniform float texelHeightOffset;
uniform vec2 iResolution;
uniform float step;

varying vec2 textureCoordinate;
varying vec2 blurCoordinates[GAUSSIAN_SAMPLES];

void main()
{
    gl_Position = position;
    textureCoordinate = inputTextureCoordinate.xy;

    // Calculate the positions for the blur
    int multiplier = 0;
    vec2 blurStep;
    vec2 singleStepOffset = vec2(texelWidthOffset * step / iResolution.x, texelHeightOffset * step / iResolution.y);
    blurCoordinates[0] = vec2(inputTextureCoordinate.x - singleStepOffset.x, inputTextureCoordinate.y - singleStepOffset.y);
    blurCoordinates[1] = vec2(inputTextureCoordinate.x + singleStepOffset.x, inputTextureCoordinate.y - singleStepOffset.y);
    blurCoordinates[2] = vec2(inputTextureCoordinate.x - singleStepOffset.x, inputTextureCoordinate.y + singleStepOffset.y);
    blurCoordinates[3] = vec2(inputTextureCoordinate.x + singleStepOffset.x, inputTextureCoordinate.y + singleStepOffset.y);

}