precision highp float;
uniform sampler2D inputImageTexture;

varying vec2 textureCoordinate;
varying vec2 oneStepBackTextureCoordinate;
varying vec2 twoStepsBackTextureCoordinate;
varying vec2 threeStepsBackTextureCoordinate;
varying vec2 fourStepsBackTextureCoordinate;
varying vec2 oneStepForwardTextureCoordinate;
varying vec2 twoStepsForwardTextureCoordinate;
varying vec2 threeStepsForwardTextureCoordinate;
varying vec2 fourStepsForwardTextureCoordinate;

void main()
{
    lowp vec3 fragmentColor = texture2D(inputImageTexture, textureCoordinate).rgb * 0.18;
    fragmentColor += texture2D(inputImageTexture, oneStepBackTextureCoordinate).rgb * 0.15;
    fragmentColor += texture2D(inputImageTexture, twoStepsBackTextureCoordinate).rgb *  0.12;
    fragmentColor += texture2D(inputImageTexture, threeStepsBackTextureCoordinate).rgb * 0.09;
    fragmentColor += texture2D(inputImageTexture, fourStepsBackTextureCoordinate).rgb * 0.05;
    fragmentColor += texture2D(inputImageTexture, oneStepForwardTextureCoordinate).rgb * 0.15;
    fragmentColor += texture2D(inputImageTexture, twoStepsForwardTextureCoordinate).rgb *  0.12;
    fragmentColor += texture2D(inputImageTexture, threeStepsForwardTextureCoordinate).rgb * 0.09;
    fragmentColor += texture2D(inputImageTexture, fourStepsForwardTextureCoordinate).rgb * 0.05;

    gl_FragColor = vec4(fragmentColor, 1.0);
}