precision highp float;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
varying vec2 textureCoordinate;

const mediump vec4 whiteColor = vec4(1.0);
uniform float intensity;
//0:mix with src
//1:mix with mask
//default:0
uniform int blendMode;

void main() {
    vec4 srcColor = texture2D(inputImageTexture, textureCoordinate);
    vec4 maskColor = texture2D(inputImageTexture2, textureCoordinate);
    vec4 screenColor = whiteColor - ((whiteColor - srcColor) * (whiteColor - maskColor));
    if (blendMode == 1) {
        gl_FragColor = mix(maskColor, screenColor, intensity);
    } else {
        gl_FragColor = mix(srcColor, screenColor, intensity);
    }
}
