precision highp float;

attribute vec4 position;
attribute vec4 inputTextureCoordinate;

varying vec2 textureCoordinate;

varying vec2 leftTextureCoordinate;
varying vec2 rightTextureCoordinate;
varying vec2 topTextureCoordinate;
varying vec2 bottomTextureCoordinate;

varying float centerMultiplier;
varying float edgeMultiplier;

uniform vec2 iResolution;
uniform float intensity;


void main() {
    gl_Position = position;
    textureCoordinate = inputTextureCoordinate.xy;
    vec2 widthStep = vec2(1./iResolution.x, 0.0);
    vec2 heightStep = vec2(0.0, 1./iResolution.y);
    leftTextureCoordinate = textureCoordinate.xy - widthStep;
    rightTextureCoordinate = textureCoordinate.xy + widthStep;
    topTextureCoordinate = textureCoordinate.xy + heightStep;
    bottomTextureCoordinate = textureCoordinate.xy - heightStep;

    centerMultiplier = 1.0 + 4.0 * intensity;
    edgeMultiplier = intensity;
}

