precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float intensity;
void main() {
    vec3 col = texture2D(inputImageTexture, textureCoordinate).rgb;

    float max = max(col.r, max(col.g, col.b));
    float avg = (col.r + col.g + col.b) / 3.0;
    float amt = (abs(max - avg) * 2.0) * intensity;
    col.r += max != col.r ? (max - col.r) * amt : 0.00;
    col.g += max != col.g ? (max - col.g) * amt : 0.00;
    col.b += max != col.b ? (max - col.b) * amt : 0.00;

    gl_FragColor = vec4(col, 1.0);
}