precision highp float;
precision highp int;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
//0->1,0,0
//1->0,1,0
//2->0,0,1
uniform vec3 channel;
//0->0.7,0.8
//1->0.7,0.8
//2->0.65,0.73
uniform vec2 threshold;
float linear(float t1, float t2, float x) {
    return (x - t1) / (t2 - t1);
}
void main() {
    vec4 iColor = texture2D(inputImageTexture, textureCoordinate);
    float x = dot(iColor.rgb,channel);
    x = max(linear(threshold.x, threshold.y, x), 0.0);
    gl_FragColor = vec4(vec3(x), 1.0);
}
