#define GAMMA_CORRECT_ENABLE
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
//R
uniform sampler2D inputImageTexture2;
//G
uniform sampler2D inputImageTexture3;
//B
uniform sampler2D inputImageTexture4;
uniform vec3 blend;
uniform float intensity;
float GammaToLinear(float a) {
    #if defined(GAMMA_CORRECT_ENABLE)
    return pow(a, 2.2);
    #else
    return a;
    #endif
}
vec3 GammaToLinear(vec3 rgb) {
    #if defined(GAMMA_CORRECT_ENABLE)
    return pow(rgb, vec3(2.2));
    #else
    return rgb;
    #endif
}
float LinearToGamma(float a) {
    #if defined(GAMMA_CORRECT_ENABLE)
    return pow(a, 0.454545);
    #else
    return a;
    #endif
}
vec3 LinearToGamma(vec3 rgb) {
    #if defined(GAMMA_CORRECT_ENABLE)
    return pow(rgb, vec3(0.454545));
    #else
    return rgb;
    #endif
}
void main() {
    vec4 iColor = texture2D(inputImageTexture, textureCoordinate);
    iColor.rgb = GammaToLinear(iColor.rgb);
    float r = texture2D(inputImageTexture2, textureCoordinate).r;
    float g = texture2D(inputImageTexture3, textureCoordinate).r;
    float b = texture2D(inputImageTexture4, textureCoordinate).r;
    vec3 bloom = vec3(r, g, b);
    const vec3 kR = vec3(0.7, 0.15, 0.15);
    #define kG (kR.yxy)
    #define kB (kR.yyx)
    bloom = vec3(dot(bloom, kR), dot(bloom, kG), dot(bloom, kB));
    bloom = GammaToLinear(bloom);

    vec3 c = clamp(iColor.rgb + bloom * blend * intensity, 0.0, 1.0);
    gl_FragColor = vec4(LinearToGamma(c), iColor.a);
}
