//#define sTexture inputImageTexture
//#define vTexCoord textureCoordinate

precision highp float;
uniform sampler2D inputImageTexture;
uniform vec2 iResolution;
//1/width , 1/height
//uniform vec2 texelStep;
varying vec2 textureCoordinate;
vec4 cubic(float x) {
    float x2 = x * x;
    float x3 = x2 * x;
    vec4 rhs = vec4(x3, x2, x, 1.0);
    const mat4 spline = mat4(-1.0, 3.0, -3.0, 1.0,
    3.0, -6.0, 3.0, 0.0,
    -3.0, 0.0, 3.0, 0.0,
    1.0, 4.0, 1.0, 0.0);
    return spline * rhs / 6.0;
}
vec4 filter_inner(sampler2D texture, vec2 texcoord, vec2 texscale) {
    float fx = fract(texcoord.x);
    float fy = fract(texcoord.y);
    texcoord.x -= fx;
    texcoord.y -= fy;
    vec4 xcubic = cubic(fx);
    vec4 ycubic = cubic(fy);
    vec4 c = vec4(texcoord.x - 0.5, texcoord.x + 1.5, texcoord.y - 0.5, texcoord.y + 1.5);
    vec4 s = vec4(xcubic.x + xcubic.y, xcubic.z + xcubic.w, ycubic.x + ycubic.y,
    ycubic.z + ycubic.w);
    vec4 offset = c + vec4(xcubic.y, xcubic.w, ycubic.y, ycubic.w) / s;
    vec4 sample0 = texture2D(texture, vec2(offset.x, offset.z) * texscale);
    vec4 sample1 = texture2D(texture, vec2(offset.y, offset.z) * texscale);
    vec4 sample2 = texture2D(texture, vec2(offset.x, offset.w) * texscale);
    vec4 sample3 = texture2D(texture, vec2(offset.y, offset.w) * texscale);
    float sx = s.x / (s.x + s.y);
    float sy = s.z / (s.z + s.w);
    return mix(mix(sample3, sample2, sx), mix(sample1, sample0, sx), sy);
}
void main() {
    vec2 texelStep = vec2(1.0 / iResolution.x, 1.0/iResolution.y);
    gl_FragColor = filter_inner(inputImageTexture, textureCoordinate * 1.0/texelStep, texelStep);
}