//vertical
precision highp float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;

uniform vec2 iResolution;
uniform int radius;
uniform float intensity;
varying float weights[30];
void main()
{

    vec2 oneStep = vec2(0.0,1.0 / iResolution.y);
    vec4 sum = texture2D(inputImageTexture, textureCoordinate) * weights[0];
    for (int i = 1; i <= radius; i++) {
        vec2 bias = oneStep * float(i);
        sum += texture2D(inputImageTexture, textureCoordinate + bias) * weights[i];
        sum += texture2D(inputImageTexture, textureCoordinate - bias) * weights[i];
    }
    gl_FragColor = sum;
}
