precision highp float;
attribute vec4 position;
uniform mat4 uMVPMatrix;
uniform mat4 uTexMatrix;
attribute vec4 inputTextureCoordinate;

varying vec2 textureCoordinate;

uniform int radius;
varying float weights[30];
uniform float intensity;
void main()
{
    float f = 0.0;
    for (int i = 0;i< radius+1; i++){
        float sqrt = (1.0 / sqrt(pow(intensity, 2.0) * 6.283185307179586)) * exp((-pow(float(i), 2.0)) / (pow(intensity, 2.0) * 2.0));
        weights[i] = sqrt;
        if (i==0) {
            f += sqrt;
        } else {
            f += (sqrt *2.0);
        }
    }
    for (int i=0;i<radius+1;i++) {
        weights[i] = weights[i]/f;
    }

    gl_Position = uMVPMatrix * position;
    textureCoordinate = (uTexMatrix * inputTextureCoordinate).xy;
}