precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float intensity;
vec3 kLuminance = vec3(0.2125, 0.7154, 0.0721);
void main()
{
    vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    vec3 color = textureColor.rgb;
    float gray = dot(kLuminance, color);

    float mask = gray;
    float mmp = smoothstep(1.0 - 0.95 * intensity, 1.0 - 0.25 * intensity, mask);
    color = color * mmp;
    gl_FragColor = vec4(color, 1.0);
}