#extension GL_OES_standard_derivatives : enable

precision highp float;

#define PI 3.141592653
#define TRANSPARENT vec4(0.)
#define WHITE vec4(1.)

varying vec2 textureCoordinate;

uniform sampler2D inputImageTexture;

uniform vec2 iResolution;
uniform float uParams[9];

vec3 shiftTexture(sampler2D tex, in vec2 size, in vec2 uv, const int x, const int y) {
    uv = uv * size.xy;
    uv = (uv + vec2(float(x), float(y))) / size.xy;
    return texture2D(tex, uv).rgb;
}

vec4 sharpenFilter(sampler2D tex, in vec2 size, in vec2 uv, float strength){
    vec3 f =
    shiftTexture(tex, size, uv, -1, -1) *  -1. +
    shiftTexture(tex, size, uv, 0, -1) *  -1. +
    shiftTexture(tex, size, uv, 1, -1) *  -1. +
    shiftTexture(tex, size, uv, -1, 0) *  -1. +
    shiftTexture(tex, size, uv, 0, 0) *   9. +
    shiftTexture(tex, size, uv, 1, 0) *  -1. +
    shiftTexture(tex, size, uv, -1, 1) *  -1. +
    shiftTexture(tex, size, uv, 0, 1) *  -1. +
    shiftTexture(tex, size, uv, 1, 1) *  -1.;
    vec4 src = texture2D(tex, uv);
    return vec4(mix(src.rgb, f, strength), src.a);
}

void main() {
    vec2 uv = textureCoordinate;
    gl_FragColor = sharpenFilter(inputImageTexture, iResolution, uv, uParams[2]);
}