#extension GL_OES_standard_derivatives : enable

precision highp float;

#define PI 3.141592653
#define TRANSPARENT vec4(0.)
#define WHITE vec4(1.)

varying vec2 textureCoordinate;

uniform sampler2D inputImageTexture;

uniform vec2 iResolution;
uniform float uParams[9];

void main() {
    vec2 uv = textureCoordinate;
    vec4 color = texture2D(inputImageTexture, uv);
    color.rgb = clamp(color.rgb-22./255., 0., 1.);
    color.r = clamp(242./247.*(color.r-8./255.), 0., 1.);
    color.g = clamp(250./245.*(color.g-10./255.), 0., 1.);
    color.b = clamp(239./238.*(color.b+16./255.), 0., 1.);
    gl_FragColor = color;
}