precision highp float;

uniform sampler2D inputImageTexture;
//bg lut
uniform sampler2D inputImageTexture2;
//skin lut
uniform sampler2D inputImageTexture3;
uniform float intensity;
uniform float mixIntensity;

varying vec2 textureCoordinate;

void main() {
    highp vec4 textureColor1 = texture2D(inputImageTexture, textureCoordinate);
    textureColor1 = clamp(textureColor1, 0.0, 1.0);

    highp float blueColor = textureColor1.b * 63.0;

    highp vec2 quad1;
    quad1.y = floor(floor(blueColor) / 8.0);
    quad1.x = floor(blueColor) - (quad1.y * 8.0);
    highp vec2 texPos1 = (quad1.xy * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor1.rg);
    lowp vec4 newColor12 = texture2D(inputImageTexture2, texPos1);
    lowp vec4 newColor22 = texture2D(inputImageTexture3, texPos1);

    vec3 final = mix(newColor12.rgb, newColor22.rgb, mixIntensity);
    final = mix(final, textureColor1.rgb, 1.-intensity);
    gl_FragColor = vec4(final, 1.0);
}
