precision mediump float;
varying highp vec2 textureCoordinate;

// varying highp vec2 textureShift_1;
// varying highp vec2 textureShift_2;
// varying highp vec2 textureShift_3;
// varying highp vec2 textureShift_4;

uniform sampler2D inputImageTexture;
// uniform sampler2D blurImageTex;
uniform sampler2D inputImageTexture2;
uniform lowp float defaultMaskValue;
uniform int useMask;

uniform lowp float blurAlpha;
uniform lowp float sharpen;

const float theta = 0.1;

vec4 smooth_v3(float smooths)
{
    vec3 centralColor;

    float mul_x = 2.0 / 720.0;
    float mul_y = 2.0 / 1280.0;

    vec2 blurCoordinates0 = textureCoordinate + vec2(0.0 * mul_x, -10.0 * mul_y);
    vec2 blurCoordinates1 = textureCoordinate + vec2(5.0 * mul_x, -8.0 * mul_y);
    vec2 blurCoordinates2 = textureCoordinate + vec2(8.0 * mul_x, -5.0 * mul_y);
    vec2 blurCoordinates3 = textureCoordinate + vec2(10.0 * mul_x, 0.0 * mul_y);
    vec2 blurCoordinates4 = textureCoordinate + vec2(8.0 * mul_x, 5.0 * mul_y);
    vec2 blurCoordinates5 = textureCoordinate + vec2(5.0 * mul_x, 8.0 * mul_y);
    vec2 blurCoordinates6 = textureCoordinate + vec2(0.0 * mul_x, 10.0 * mul_y);
    vec2 blurCoordinates7 = textureCoordinate + vec2(-5.0 * mul_x, 8.0 * mul_y);
    vec2 blurCoordinates8 = textureCoordinate + vec2(-8.0 * mul_x, 5.0 * mul_y);
    vec2 blurCoordinates9 = textureCoordinate + vec2(-10.0 * mul_x, 0.0 * mul_y);
    vec2 blurCoordinates10 = textureCoordinate + vec2(-8.0 * mul_x, -5.0 * mul_y);
    vec2 blurCoordinates11 = textureCoordinate + vec2(-5.0 * mul_x, -8.0 * mul_y);

    mul_x = 1.6 / 720.0;
    mul_y = 1.6 / 1080.0;

    vec2 blurCoordinates12 = textureCoordinate + vec2(0.0 * mul_x, -6.0 * mul_y);
    vec2 blurCoordinates13 = textureCoordinate + vec2(-4.0 * mul_x, -4.0 * mul_y);
    vec2 blurCoordinates14 = textureCoordinate + vec2(-6.0 * mul_x, 0.0 * mul_y);
    vec2 blurCoordinates15 = textureCoordinate + vec2(-4.0 * mul_x, 4.0 * mul_y);
    vec2 blurCoordinates16 = textureCoordinate + vec2(0.0 * mul_x, 6.0 * mul_y);
    vec2 blurCoordinates17 = textureCoordinate + vec2(4.0 * mul_x, 4.0 * mul_y);
    vec2 blurCoordinates18 = textureCoordinate + vec2(6.0 * mul_x, 0.0 * mul_y);
    vec2 blurCoordinates19 = textureCoordinate + vec2(4.0 * mul_x, -4.0 * mul_y);

    float central;
    float gaussianWeightTotal;
    float sum;
    float samples;
    float distanceFromCentralColor;
    float gaussianWeight;

    float distanceNormalizationFactor = 3.6;

    central = texture2D(inputImageTexture, textureCoordinate).g;
    gaussianWeightTotal = 0.2;
    sum = central * 0.2;

    samples = texture2D(inputImageTexture, blurCoordinates0).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates1).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates2).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates3).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates4).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates5).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates6).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates7).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates8).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates9).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates10).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates11).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.08 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates12).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates13).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates14).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates15).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates16).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates17).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates18).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    samples = texture2D(inputImageTexture, blurCoordinates19).g;
    distanceFromCentralColor = min(abs(central - samples) * distanceNormalizationFactor, 1.0);
    gaussianWeight = 0.1 * (1.0 - distanceFromCentralColor);
    gaussianWeightTotal += gaussianWeight;
    sum += samples * gaussianWeight;

    sum = sum/gaussianWeightTotal;

    centralColor = texture2D(inputImageTexture, textureCoordinate).rgb;

    samples = centralColor.g - sum + 0.5;

    for (int i = 0; i < 5; ++i)
    {
        if (samples <= 0.5)
        {
            samples = samples * samples * 2.0;
        }
        else
        {
            samples = 1.0 - ((1.0 - samples)*(1.0 - samples) * 2.0);
        }
    }

    float aa = 1.0 + pow(sum, 0.3)*0.09;
    vec3 smoothColor = centralColor*aa - vec3(samples)*(aa-1.0);// get smooths color
    smoothColor = clamp(smoothColor, vec3(0.0), vec3(1.0));//make smooths color right

    smoothColor = mix(centralColor, smoothColor, pow(centralColor.g, 0.33));
    smoothColor = mix(centralColor, smoothColor, pow(centralColor.g, 0.39));

    smoothColor = mix(centralColor, smoothColor, smooths);

    return vec4(pow(smoothColor, vec3(0.96)), 1.0);
}

void main()
{
    //firstly, smooths
    // lowp vec4 preColor = texture2D(blurImageTex, textureCoordinate);

    // lowp vec4 inColor = texture2D(inputImageTexture, textureCoordinate);
    // lowp vec3 meanColor = preColor.rgb;


    // mediump float p = clamp((min(inColor.r, meanColor.r-0.1)-0.2)*4.0, 0.0, 1.0);
    // mediump float kMin = (1.0 - preColor.a / (preColor.a + theta)) * p * blurAlpha;

    //use mask
    lowp float maskValue = defaultMaskValue;
    if (useMask == 1) {
        lowp vec3 mask_rgb = texture2D(inputImageTexture2, textureCoordinate).rgb;
        lowp float threshold = 0.005;
        if (mask_rgb.r > threshold && mask_rgb.b <= threshold) {
            maskValue = mask_rgb.r;
        } else if (mask_rgb.r > threshold && mask_rgb.b > threshold) {
            maskValue = 1.0 - mask_rgb.b;
        }
    }

    // lowp vec3 smoothColor = mix(inColor.rgb, meanColor.rgb, kMin * maskValue);


    gl_FragColor = smooth_v3(blurAlpha * maskValue);
}