precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float uTime;
uniform float intensity;

// 2D Random
float random(vec2 st) {
    return fract(sin(dot(st.xy, vec2(12.9898, 78.233))) * 43758.5453123);
}

float noise(vec2 st) {
    vec2 i = floor(st);
    vec2 f = fract(st);

    // Four corners in 2D of a tile
    float a = random(i);
    float b = random(i + vec2(1.0, 0.0));
    float c = random(i + vec2(0.0, 1.0));
    float d = random(i + vec2(1.0, 1.0));

    // Smooth Interpolation

    // Cubic Hermine Curve.  Same as SmoothStep()
    vec2 u = f * f * (3.0 - 2.0 * f);
    // u = smoothstep(0.,1.,f);

    // Mix 4 coorners percentages
    return mix(a, b, u.x) +
    (c - a) * u.y * (1.0 - u.x) +
    (d - b) * u.x * u.y;
}

void main()
{
    float strengthPower = 1.0 * intensity;
    float strength = 16.0 * strengthPower;
    float x = (textureCoordinate.x + 4.0) * (textureCoordinate.y + 224.0) * (mod(uTime, 10.0) + 3.0);
    vec4 grain = vec4(mod((mod(x, 13.0) + 1.0) * (mod(x, 123.0) + 1.0), 0.01) - 0.005) * strength;
    vec4 color1 = texture2D(inputImageTexture, textureCoordinate);

    vec4 resultColor = color1 + grain;
    resultColor.a = color1.a;
    gl_FragColor = resultColor;

    // gl_FragColor = leftupCol;
    // gl_FragColor = color1;
}