precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float time;
vec2 hash(vec2 p){
    vec3 p3 = fract(vec3(p.x, p.y, p.x) * vec3(166.1031, 147.1030, 142.0973));
    p3 += dot(p3, p3.yzx + 33.33);
    return fract((p3.xx + p3.yz) * p3.zy);
}

float verticalLine(vec2 uv, float time)
{
    float uvX = uv.x + time*0.0000003;
    vec2 xHash = hash(vec2(uvX, uvX));
    float vertical = step(0.9999996, sin(uvX*1000.0 * (xHash.x*0.01+0.01)));

    float uvY = uv.y + time*0.000001;
    vec2 yHash = hash(vec2(uvY, uvY));
    vertical *= sin(uvY*1000.0 * (yHash.x));
    //return saturate(1.0 - vertical);
    return clamp(vertical,0.,1.);
}
void main() {
    vec4 base = texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor = vec4(base.rgb + verticalLine(textureCoordinate, time), base.a);
}