precision highp float;
varying vec2 textureCoordinate;
varying vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float opacity;

// screen
float blendScreen(float base, float blend) {
    return 1.0 - ((1.0 - base) * (1.0 - blend));
}

vec3 blendScreen(vec3 base, vec3 blend) {
    return vec3(blendScreen(base.r, blend.r), blendScreen(base.g, blend.g), blendScreen(base.b, blend.b));
}

void main() {
    vec4 base = texture2D(inputImageTexture, textureCoordinate);
    vec4 blend = texture2D(inputImageTexture2, textureCoordinate2);

    vec3 result = blendScreen(base.rgb, blend.rgb) * opacity + base.rgb * (1.0 - opacity);
    gl_FragColor = vec4(result, base.a);
}