precision highp float;
precision highp int;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
varying highp vec2 textureCoordinate3;

uniform float opacity;
uniform bool enable;

void main() {
    if (enable) {
        vec4 base = texture2D(inputImageTexture, textureCoordinate);
        vec4 overlay = texture2D(inputImageTexture2, textureCoordinate2) * opacity;
        vec4 overlay2 = texture2D(inputImageTexture3, textureCoordinate3) * opacity;

        vec4 concat1 = base + overlay - base * overlay.a;
        vec4 concat2 = concat1 + overlay2 - concat1 * overlay2.a;
        gl_FragColor = concat2;
    } else {
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    }
}