// FindEdge v1.0
// lujing.zd@bytedance.com 2020_05_13
// SobelEdgeDetection: https://gist.github.com/Hebali/6ebfc66106459aacee6a9fac029d0115

precision highp float;
// uniform
// Reciprocal screen width
uniform highp float recScreenWidth;
// Inverse screen height
uniform highp float recScreenHight;
// Edge of the range
uniform float edgeRange;
// attribute
// Vertex positions
attribute vec4 position;
// UV
attribute vec4 inputTextureCoordinate;
// varying
// KernelUVs
varying highp vec2 kernelUVs[9];
varying highp vec2 textureCoordinate;

void main()
{
    // Vertex positions
    gl_Position = position;
    // KernelUVs
    highp float stepU = recScreenWidth * edgeRange;
    highp float stepV = recScreenHight * edgeRange;
    kernelUVs[0] = inputTextureCoordinate.xy + vec2(-stepU,  -stepV);
    kernelUVs[1] = inputTextureCoordinate.xy + vec2(0.0,     -stepV);
    kernelUVs[2] = inputTextureCoordinate.xy + vec2(stepU,   -stepV);
    kernelUVs[3] = inputTextureCoordinate.xy + vec2(-stepU,  0.0);
    kernelUVs[4] = inputTextureCoordinate.xy + vec2(0.0,     0.0);
    kernelUVs[5] = inputTextureCoordinate.xy + vec2(stepU,   0.0);
    kernelUVs[6] = inputTextureCoordinate.xy + vec2(-stepU,  stepV);
    kernelUVs[7] = inputTextureCoordinate.xy + vec2(0.0,     stepV);
    kernelUVs[8] = inputTextureCoordinate.xy + vec2(stepU,   stepV);
    textureCoordinate = inputTextureCoordinate.xy;
}