// GaussBlur x9 v1.0
// lujing.zd@bytedance.com 2020_05_19
// Gaussian blur (uniaxial 9 times sampling)

precision highp float;
// uniform
// Source texture
uniform sampler2D inputImageTexture;
// varying
// BlurUVs
varying highp vec2 blurUVs[7];
//varying highp vec2 blurUVs[9];
varying highp vec2 textureCoordinate;

void main() {
    // Cumulative sampling
    lowp vec4 sum = vec4(0.0, 0.0, 0.0, 0.0);
    sum += texture2D(inputImageTexture, blurUVs[0]) * 0.4;
    sum += texture2D(inputImageTexture, blurUVs[1]) * 0.15;
    sum += texture2D(inputImageTexture, blurUVs[2]) * 0.15;
    sum += texture2D(inputImageTexture, blurUVs[3]) * 0.1;
    sum += texture2D(inputImageTexture, blurUVs[4]) * 0.1;
    sum += texture2D(inputImageTexture, blurUVs[5]) * 0.05;
    sum += texture2D(inputImageTexture, blurUVs[6]) * 0.05;

    gl_FragColor = sum;
}