// GaussBlur x9 v1.0
// lujing.zd@bytedance.com 2020_05_19
// Gaussian blur (uniaxial 9 times sampling 单轴9次取样)

precision highp float;
// uniform
// Reciprocal screen width
uniform highp float recScreenWidth;
// Inverse screen height
uniform highp float recScreenHight;
// Fuzzy radius
uniform highp float blurRange;
// attribute
// Vertex positions
attribute vec4 position;
// UV
attribute vec4 inputTextureCoordinate;
// varying
// BlurUVs
varying highp vec2 blurUVs[7];
varying highp vec2 textureCoordinate;

// varying highp vec2 blurUVs[9];

void main()
{
    // Vertex positions
    gl_Position = position;
    // BlurUVs
    vec2 uvBias = vec2(recScreenWidth, recScreenHight) * blurRange;
    blurUVs[0] = inputTextureCoordinate.xy;
    blurUVs[1] = inputTextureCoordinate.xy + uvBias * 2.4;
    blurUVs[2] = inputTextureCoordinate.xy - uvBias * 2.4;
    blurUVs[3] = inputTextureCoordinate.xy + uvBias * 4.8;
    blurUVs[4] = inputTextureCoordinate.xy - uvBias * 4.8;
    blurUVs[5] = inputTextureCoordinate.xy + uvBias * 7.2;
    blurUVs[6] = inputTextureCoordinate.xy - uvBias * 7.2;
    textureCoordinate = inputTextureCoordinate.xy;
    // blurUVs[1] = attUV + uvBias * 1.458430;
    // blurUVs[2] = attUV - uvBias * 1.458430;
    // blurUVs[3] = attUV + uvBias * 3.403985;
    // blurUVs[4] = attUV - uvBias * 3.403985;
    // blurUVs[5] = attUV + uvBias * 5.351806;
    // blurUVs[6] = attUV - uvBias * 5.351806;
    // blurUVs[7] = attUV + uvBias * 7.302940;
    // blurUVs[8] = attUV - uvBias * 7.302940;
}
