precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec2 iResolution;
void main()
{
    float inputRatio = float(iResolution.x) / float(iResolution.y);
    vec2 uv1 = textureCoordinate;
    if(inputRatio > 1.0) {
        uv1 -= 0.5;
        uv1.y *= inputRatio;
        uv1 += 0.5;
    }
    if(inputRatio < 1.0) {
        uv1 -= 0.5;
        uv1.x /= inputRatio;
        uv1 += 0.5;
    }

    gl_FragColor = texture2D(inputImageTexture, uv1);
}
