precision highp float;
varying vec2 textureCoordinate;
varying vec2 textureCoordinate2;
varying vec2 textureCoordinate3;
uniform sampler2D inputImageTexture;
//cutTexture
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
//R
//uniform float radius;
//value
uniform float intensity;

uniform vec2 iResolution;
uniform float overlayOpacity;
#define PI 3.1415926

void main() {
    float radius = 0.68 * 0.8;
    radius = radius * (min(iResolution.x, iResolution.y) / max(iResolution.x, iResolution.y));
    float inputRatio = float(iResolution.x) / float(iResolution.y);
    vec2 uv1 = vec2(textureCoordinate.x, textureCoordinate.y);
    if (inputRatio > 1.0) {
        uv1 -= 0.5;
        uv1.y /= inputRatio;
        uv1 += 0.5;
    }
    if (inputRatio < 1.0) {
        uv1 -= 0.5;
        uv1.x *= inputRatio;
        uv1 += 0.5;
    }
    vec2 center = vec2(0.5);
    if (distance(uv1, center) <= radius) {
        uv1 -= center;
        // uv1 *= rat;
        float fishEyeRate = intensity;
        float n = radius;
        float radius = length(uv1);
        float power = PI / n * fishEyeRate / 10.;

        uv1 = normalize(uv1) * tan(radius * power) * n / tan(n * power);
        uv1 += center;
        if (fishEyeRate <= 0.001)
        // uv1 = textureCoordinate;
        uv1 = textureCoordinate;
    }

    vec4 cutColor = texture2D(inputImageTexture2, uv1);
    vec4 inputColor = texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor = inputColor;
    gl_FragColor.a = inputColor.a;
    if (intensity > 0.0001){
        gl_FragColor = cutColor;
        gl_FragColor.a = cutColor.a;
    }

    //vec2 uv2 = textureCoordinate2.xy * iResolution.xy / overlaySize.xy;
    vec4 c1 = texture2D(inputImageTexture3, textureCoordinate3) * overlayOpacity;
    vec4 c2 = gl_FragColor;

    lowp vec4 outputColor;
    outputColor.r = c1.r + c2.r * c2.a * (1.0 - c1.a);
    outputColor.g = c1.g + c2.g * c2.a * (1.0 - c1.a);

    outputColor.b = c1.b + c2.b * c2.a * (1.0 - c1.a);

    outputColor.a = c1.a + c2.a * (1.0 - c1.a);

    gl_FragColor = outputColor;

}