precision highp float;
varying vec2 textureCoordinate;
#define KERNEL_SIZE 9

uniform sampler2D inputImageTexture;
mat4 kernel = mat4(0.0,-1.0,0.0,0.0,
-1.0,2.0,2.0,0.0,
0.0,-1.0,0.0,0.0,
0.0,0.0,0.0,0.0);

uniform vec2 iResolution;
//uniform int imageWidth;
//uniform int imageHeight;
uniform int sharpen;

void main() {
    vec2 uv = textureCoordinate;
    vec4 color = vec4(0);

    if (sharpen == 1) {
        for (int i = 0; i < KERNEL_SIZE; i++) {
            float row = floor(float(i) / 3.);
            float col = mod(float(i), 3.);
            uv.x += (col - 1.) * 1. / float(iResolution.x);
            uv.y += (row - 1.) * 1. / float(iResolution.y);
            color += texture2D(inputImageTexture, uv) * kernel[int(row)][int(col)];
        }
    } else {
        color = texture2D(inputImageTexture, uv);
    }
    gl_FragColor = color;
    gl_FragColor = clamp(gl_FragColor, 0.0, gl_FragColor.a);
}
