precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D rawImageTexture;
uniform vec2 iResolution;
uniform float zoom;

void main() {
    vec2 uv = textureCoordinate;
    if (zoom > 1.01) {
        uv = floor(uv / (zoom / iResolution) + .5) * zoom / iResolution;
    }
    vec4 color = texture2D(inputImageTexture, uv);
    gl_FragColor = color;
    gl_FragColor = clamp(gl_FragColor, 0.0, gl_FragColor.a);
}
