precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform vec2 iResolution;
//uniform int imageWidth;
//uniform int imageHeight;

uniform float light;
uniform float contrast;
uniform float intensity; // zhuyizhegeshihuagandeuniform

uniform int darkFade;
uniform int brightFade;

uniform float vividU;
uniform float vividV;
uniform int shiftU;
uniform int shiftV;
uniform int level;

uniform int shiftX;
uniform int shiftY;

float hash13(vec3 p3)
{
    p3  = fract(p3 * .1031);
    p3 += dot(p3, p3.yzx + 33.33);
    return fract((p3.x + p3.y) * p3.z);
}

int randRange(int a, int b) {
    return int(hash13(gl_FragCoord.xyz) * float(b - a) + float(a));
}

vec3 rgb2yuv(float r, float g, float b) {
    return vec3(
    floor(r *  .299000 + g *  .587000 + b *  .114000),
    floor(r * -.168736 + g * -.331264 + b *  .500000 + 128.),
    floor(r *  .500000 + g * -.418688 + b * -.081312 + 128.)
    );
}

vec3 yuv2rgb(float y, float u, float v) {
    return vec3(
    clamp(floor(y + 1.4075 * (v - 128.)), 0., 255.),
    clamp(floor(y - 0.3455 * (u - 128.) - (0.7169 * (v - 128.))), 0., 255.),
    clamp(floor(y + 1.7790 * (u - 128.)), 0., 255.)
    );
}

void main(void)
{

    vec4 color = texture2D(inputImageTexture, textureCoordinate);
    vec4 baseColor = color;
    color.rgb *= 255.;
    color.rgb = rgb2yuv(color.r, color.g, color.b);

    vec2 uv2 = textureCoordinate;
    uv2.x += float(shiftX) / float(iResolution.x);
    vec4 color2 = texture2D(inputImageTexture, fract(uv2));
    color2.rgb *= 255.;
    color2.rgb = rgb2yuv(color2.r, color2.g, color2.b);

    vec2 uv3 = textureCoordinate;
    uv3.y += float(shiftY) / float(iResolution.y);
    vec4 color3 = texture2D(inputImageTexture, fract(uv3));
    color3.rgb *= 255.;
    color3.rgb = rgb2yuv(color3.r, color3.g, color3.b);

    color.r = (color.r - float(128)) * contrast + float(128);
    color.r *= light;
    color.r = max(color.r, float(darkFade));
    color.r = min(color.r, float(255 - brightFade));

    color.g = min(255., (color2.g - 128.) * vividU + float(shiftU + 128));
    color.b = min(255., (color3.b - 128.) * vividV + float(shiftV + 128));
    color.g = floor(color.g / float(level)) * float(level);
    color.b = floor(color.b / float(level)) * float(level);

    color.rgb = yuv2rgb(color.r, color.g, color.b) / 255.;
    gl_FragColor = mix(baseColor, color, intensity);
    gl_FragColor = clamp(gl_FragColor, 0.0, gl_FragColor.a);
    // gl_FragColor = vec4(intensity, 0.0, 0.0, 1.0);
}
