precision highp float;
//uniform vec2 iResolution;
//原始纹理?
uniform sampler2D inputImageTexture;
////高光区颜色取值纹理，图片
//uniform sampler2D inputImageTexture2;
//第一次模糊纹理
uniform sampler2D inputImageTexture2;
//第二次模糊纹理
uniform sampler2D inputImageTexture3;
//原始纹理
uniform sampler2D inputImageTexture4;
//辉光颜色取值偏移,0-1
//uniform float colorIntensity;
//辉光透明度,0-10
uniform float brightness;

uniform vec4 color;
//是否有背景,默认0
//uniform int hasBgTex;

//uniform vec3 GlowColor;
//叠加模式(0:滤色，1:相加，2:正片叠底，3:插值，4:叠加)
uniform int combine;
uniform float glowUnderSource;
uniform float sourceOpacity;

//uniform float lightBackground;
//uniform float bgBrightness;
//uniform vec2 bgTextureSize;
varying highp vec2 textureCoordinate;

//#define BlendOverlayf(base, blend)      (base < 0.5 ? (2.0 * base * blend) : (1.0 - 2.0 * (1.0 - base) * (1.0 - blend)))
//#define BlendOverlay(base, blend)       vec3(BlendOverlayf(base.r, blend.r), BlendOverlayf(base.g, blend.g), BlendOverlayf(base.b, blend.b))
//#define BlendScreen(base, blend)        (1.0 - (1.0 - base) * (1.0 - blend))
//#define BlendMultiply(base, blend)      (base * blend)
//#define BlendDifference(base, blend)    (abs(blend - base))
//#define BlendAdd(base, blend)           (blend + base)

float BlendOverlayf(float base, float blend) {
    return (base < 0.5 ? (2.0 * base * blend) : (1.0 - 2.0 * (1.0 - base) * (1.0 - blend)));
}

vec3 BlendOverlay(vec3 base, vec3 blend) {
    return vec3(BlendOverlayf(base.r, blend.r), BlendOverlayf(base.g, blend.g), BlendOverlayf(base.b, blend.b));
}

vec3 BlendScreen(vec3 base, vec3 blend) {
    return (1.0 - (1.0 - base) * (1.0 - blend));
}

vec3 BlendMultiply(vec3 base, vec3 blend) {
    return (base * blend);
}

vec3 BlendDifference(vec3 base, vec3 blend) {
    return (abs(blend - base));
}

vec3 BlendAdd(vec3 base, vec3 blend) {
    return (blend + base);
}

float cut(vec2 u) { return step(0., u.x) * step(u.x, 1.) * step(0., u.y) * step(u.y, 1.); }

vec2 vec4ToVec2(vec4 val)
{
    float a = val.x + val.y / 255.0;
    float b = val.z + val.w / 255.0;
    return vec2(a, b);
}

vec4 vec2ToVec4(vec2 val)
{
    float a = floor(val.x * 255.0) / 255.0;
    float b = fract(val.x * 255.0);
    float c = floor(val.y * 255.0) / 255.0;
    float d = fract(val.y * 255.0);
    return vec4(a, b, c, d);
}

void main()
{
    vec4 inputColor = texture2D(inputImageTexture, textureCoordinate);
    inputColor.rgb /= (inputColor.a+0.0001);
    vec4 maskColor = texture2D(inputImageTexture4, textureCoordinate);
    float black = 0. / 255.;
    float smoothBlack = 0. / 255.;
    float white = 152. / 255.;
    float smoothWhite = 57. / 255.;
    float grey = maskColor.r;
    maskColor *= smoothstep(-smoothBlack, 0., grey - black);
    maskColor *= smoothstep(-smoothWhite, 0., white - grey);
    vec4 bgColor = vec4(0.0, 0.0, 0.0, inputColor.a);
    bgColor = inputColor;//mix(bgColor, inputColor, sourceOpacity);

    vec4 blurColor = vec4(vec4ToVec2(texture2D(inputImageTexture2, textureCoordinate)), vec4ToVec2(texture2D(inputImageTexture3, textureCoordinate)));
    blurColor.rgb /= (blurColor.a+0.0001);
    vec4 colorV = color;//texture2D(inputImageTexture2, vec2(colorIntensity, .5));
    blurColor.rgb *= colorV.rgb;// GlowColor;
    blurColor.rgb *= brightness;
    // gl_FragColor = blurColor; return;

    vec4 fgBlurColor = blurColor;
    fgBlurColor = mix(fgBlurColor, mix(fgBlurColor, inputColor, sourceOpacity), glowUnderSource);
    //fgBlurColor *= (1.0 - lightBackground);

    bgColor = clamp(bgColor, 0.0, 1.0);
    fgBlurColor = clamp(fgBlurColor, 0.0, 1.0);

    vec4 resultColor = vec4(0.);
    if (combine == 1) resultColor = vec4(BlendAdd(bgColor.rgb, fgBlurColor.rgb), 1.0) * inputColor.a;
    else if (combine == 2) resultColor = vec4(BlendMultiply(bgColor.rgb, fgBlurColor.rgb), 1.0) * inputColor.a;
    else if (combine == 3) resultColor = vec4(BlendDifference(bgColor.rgb, fgBlurColor.rgb), 1.0) * inputColor.a;
    else if (combine == 4) resultColor = vec4(BlendOverlay(bgColor.rgb, fgBlurColor.rgb), 1.0) * inputColor.a;
    else resultColor = vec4(BlendScreen(bgColor.rgb, fgBlurColor.rgb), 1.0) * inputColor.a;

    resultColor = mix(inputColor, resultColor, maskColor.a);
    gl_FragColor = resultColor;
}
