precision highp float;
varying highp vec2 textureCoordinate;

uniform vec2 iResolution;
//0-0.8
uniform float intensity;
uniform float colorIntensity;
////0-1
//float u_intensityR = 0.1;
////0-1
//float u_intensityG = 0.1;
////0-1
//float u_intensityB = 0.1;
////0.22-1
//float u_scale = 0.3;
////0.2-1
//float u_scaleR = 1.0;
////0.2-1
//float u_scaleG = 1.0;
////0.2-1
//float u_scaleB = 1.0;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture3;
//边框颜色
vec3 u_borderColor = vec3(1.0,1.0,1.0);
//边框宽度，0-50
float u_borderWidth = 0.0;
//noise render rect center(0-1)
vec2 noiseCenter = vec2(0.5,0.5);
//noise render rect size(0-1)
vec2 noiseRange = vec2(1.0,1.0);
//Screen = 0, Add = 1, Mult = 2, Overlay = 3, Film = 4, Difference = 5
uniform int blendMode;
float u_radius = 0.0;
float u_smoothing = 0.0;
vec3 factor1 = vec3(0.0,0.0,0.0);
//uniform float u_seed;
uniform sampler2D inputImageTexture2;
//random seed,0-1
uniform float noiseSeed;


//#define BlendOverlayf(base, blend)      (base < 0.5 ? (2.0 * base * blend) : (1.0 - 2.0 * (1.0 - base) * (1.0 - blend)))
//#define BlendOverlay(base, blend)       vec3(BlendOverlayf(base.r, blend.r), BlendOverlayf(base.g, blend.g), BlendOverlayf(base.b, blend.b))
//#define BlendColorBurnf(base, blend)    ((blend == 0.0) ? blend : max((1.0 - ((1.0 - base) / blend)), 0.0))
//#define BlendColorBurn(base, blend)     vec3(BlendColorBurnf(base.r, blend.r), BlendColorBurnf(base.g, blend.g), BlendColorBurnf(base.b, blend.b))
//#define BlendScreen(base, blend)        (1.0 - (1.0 - base) * (1.0 - blend))
//#define BlendMultiply(base, blend)      (base * blend)
//#define BlendDifference(base, blend)    (abs(blend - base))
//#define BlendAdd(base, blend)           (blend + base)

float BlendOverlayf(float base, float blend) {
    return (base < 0.5 ? (2.0 * base * blend) : (1.0 - 2.0 * (1.0 - base) * (1.0 - blend)));
}

vec3 BlendOverlay(vec3 base, vec3 blend) {
    return vec3(BlendOverlayf(base.r, blend.r), BlendOverlayf(base.g, blend.g), BlendOverlayf(base.b, blend.b));
}

float BlendColorBurnf(float base, float blend) {
    return ((blend == 0.0) ? blend : max((1.0 - ((1.0 - base) / blend)), 0.0));
}

vec3 BlendColorBurn(vec3 base, vec3 blend) {
    return vec3(BlendColorBurnf(base.r, blend.r), BlendColorBurnf(base.g, blend.g), BlendColorBurnf(base.b, blend.b));
}

vec3 BlendScreen(vec3 base, vec3 blend) {
    return (1.0 - (1.0 - base) * (1.0 - blend));
}

vec3 BlendMultiply(vec3 base, vec3 blend) {
    return (base * blend);
}

vec3 BlendDifference(vec3 base, vec3 blend) {
    return (abs(blend - base));
}

vec3 BlendAdd(vec3 base, vec3 blend) {
    return (blend + base);
}

// https://editor.isf.video/shaders/639b687b24251a001ac033d8
float roundedRectMask(vec2 uv, vec2 center, vec2 size, float radius, float aspectRatio, float smoothing)
{
    vec2 aspectCorrection = vec2(1.0, aspectRatio);

    float cornerSDF = distance(
    aspectCorrection * abs(uv - center),
    aspectCorrection * size / 2.0 - radius
    );
    vec2 centerSDF = aspectCorrection * (abs(uv - center) - size / 2.0) + radius;

    float cornerMask =
    step(0.0, centerSDF.y) *
    step(0.0, centerSDF.x) *
    smoothstep(cornerSDF - smoothing, cornerSDF + smoothing, radius);
    float horizontalMask =
    step(centerSDF.x, 0.0) *
    smoothstep(centerSDF.y - smoothing, centerSDF.y + smoothing, radius);
    float verticalMask =
    (1.0 - horizontalMask) *
    step(centerSDF.y, 0.0) *
    smoothstep(centerSDF.x - smoothing, centerSDF.x + smoothing, radius);
    return cornerMask + horizontalMask + verticalMask;
}

vec4 saturation(vec4 color, float sat)
{
    vec3 temp1_1;
    lowp vec4 res_2;
    vec3 tmpvar_3;
    tmpvar_3 = (factor1 / ((
    (factor1.x + factor1.y)
    + factor1.z) / 0.02));
    float tmpvar_4;
    tmpvar_4 = (50.0 - sat*100.0);
    lowp vec4 tmpvar_5 = color;
    res_2.w = tmpvar_5.w;
    vec3 tmpvar_6;
    tmpvar_6.x = 0.0;
    tmpvar_6.y = (tmpvar_3.x * tmpvar_4);
    tmpvar_6.z = (tmpvar_3.y * tmpvar_4);
    temp1_1.yz = tmpvar_6.yz;
    temp1_1.x = ((1.0 - tmpvar_6.z) - tmpvar_6.y);
    res_2.x = dot (tmpvar_5.xyz, temp1_1);
    vec3 tmpvar_7;
    tmpvar_7.y = 0.0;
    tmpvar_7.x = (tmpvar_3.z * tmpvar_4);
    tmpvar_7.z = (tmpvar_3.y * tmpvar_4);
    temp1_1.xz = tmpvar_7.xz;
    temp1_1.y = ((1.0 - tmpvar_7.x) - tmpvar_7.z);
    res_2.y = dot (tmpvar_5.xyz, temp1_1);
    vec3 tmpvar_8;
    tmpvar_8.z = 0.0;
    tmpvar_8.x = (tmpvar_3.z * tmpvar_4);
    tmpvar_8.y = (tmpvar_3.x * tmpvar_4);
    temp1_1.xy = tmpvar_8.xy;
    temp1_1.z = ((1.0 - tmpvar_8.x) - tmpvar_8.y);
    res_2.z = dot (tmpvar_5.xyz, temp1_1);
    return res_2;
}


vec2 hash(vec2 p, float seed)
{
    vec3 p3 = fract(vec3(p.xyx) * vec3(.1031, .1030, .0973));
    p3 += dot(p3, p3.yzx+33.33 + seed);
    return fract((p3.xx+p3.yz)*p3.zy) * 2.0 - 1.0;
}

float noise(in vec2 p, float i_step, float seed, float scale)
{
    vec2 i = vec2(floor(p / i_step));
    vec2 f = fract(p / (i_step));

    vec2 u = f * f * (f * (6.0 * f - 15.0) + 10.0);// feel free to replace by a quintic smoothstep instead
    u = mix(f * u, u, smoothstep(0.3, 0.25, scale));

    /* return mix( mix(  hash( (i+vec2(0,0))*i_step ).x,
                       hash( (i+vec2(1,0))*i_step ).x, u.x),
                 mix(  hash( (i+vec2(0,1))*i_step ).x,
                       hash( (i+vec2(1,1))*i_step ).x, u.x), u.y);*/

    return mix(mix(dot(hash((i+vec2(0, 0))*i_step, seed), f-vec2(0.0, 0.0)),
    dot(hash((i+vec2(1, 0))*i_step, seed), f-vec2(1.0, 0.0)), u.x),
    mix(dot(hash((i+vec2(0, 1))*i_step, seed), f-vec2(0.0, 1.0)),
    dot(hash((i+vec2(1, 1))*i_step, seed), f-vec2(1.0, 1.0)), u.x), u.y);
}

float grain(vec2 uv, float scale, float seed)
{
    float k = 2.0/max(0.1, scale);
    float n = noise(uv * 500.0, 500.0 / pow(2.0, floor(k)), seed, scale) * 0.5 + 0.5;
    float n2 = noise(uv * 300.0, 300.0 / pow(2.0, floor(k)), seed, scale) * 0.5 + 0.5;
    n = 0.6*n+0.4*n2;
    float n1 = noise(uv * 500.0, 500.0 / pow(2.0, floor(k) + 1.0), seed, scale) * 0.5 + 0.5;
    float n3 = noise(uv * 300.0, 300.0 / pow(2.0, floor(k) + 1.0), seed, scale) * 0.5 + 0.5;
    n1 = 0.6*n1+0.4*n3;
    n = mix(n, n1, fract(k));
    return n;
}
vec3 hash23(vec2 p){
    vec3 p3 = fract(p.xyx*234.5);
    p3+=dot(p3, p3.yzx+15.4);
    return fract((p3.xyz+p3.yzx)*p3.zyx);
}
float colorAdjust(float c, float brightness, float contrast)
{
    c += brightness*0.3;
    if (contrast>0.0)
    {
        c = (c-0.5)*(contrast*10.0+1.0) + 0.5;
    }
    else
    {
        c = (c-0.5)*(contrast+1.0) + 0.5;
    }
    // c = clamp(c, 0.0, 1.0);
    return c;
}

void main()
{
    vec2 st_0 = textureCoordinate;
    st_0.x *= iResolution.x / iResolution.y;

    // float n_r = grain(st_0, u_scale * u_scaleR, u_seed);
    // float n_g = n_r;
    // float n_b = n_r;
    // if (u_monochrome == 0)
    // {
    //     n_g = grain(st_0, u_scale * u_scaleG, u_seed + 2.0);
    //     n_b = grain(st_0, u_scale * u_scaleB, u_seed + 4.0);
    // }

    // n_r = colorAdjust(n_r, u_Brightness, u_Contrast);
    // n_g = colorAdjust(n_g, u_Brightness, u_Contrast);
    // n_b = colorAdjust(n_b, u_Brightness, u_Contrast);

    // if (blendMode == 1 || blendMode == 2)
    // {
    //     n_r = (n_r-0.5)*2.0;
    //     n_g = (n_g-0.5)*2.0;
    //     n_b = (n_b-0.5)*2.0;
    // }
    // else if (blendMode == 0)
    // {
    //     n_r = abs(n_r - 0.5) * 2.0;
    //     n_g = abs(n_g - 0.5) * 2.0;
    //     n_b = abs(n_b - 0.5) * 2.0;
    // }
    // vec3 noiseColor = vec3(n_r, n_g, n_b);
    // noiseColor.rgb = saturation(vec4(noiseColor, 1.0), u_Saturation).rgb;
    vec2 noiseTexUV = textureCoordinate;
    if (iResolution.x<iResolution.y){
        noiseTexUV.x*=iResolution.x/iResolution.y;
    }
    else
    {
        noiseTexUV.y*=iResolution.y/iResolution.x;
    }
    vec3 noiseColor = texture2D(inputImageTexture2, vec2(noiseTexUV.x + noiseSeed,noiseTexUV.y)).rgb;

    vec4 inputColor = texture2D(inputImageTexture, textureCoordinate);

    vec4 fgColor;
    if (blendMode == 1) fgColor = vec4(BlendAdd(inputColor.rgb, noiseColor.rgb), inputColor.a);
    else if (blendMode == 2) fgColor = vec4(BlendMultiply(inputColor.rgb, noiseColor.rgb), inputColor.a);
    else if (blendMode == 3) fgColor = vec4(BlendOverlay(inputColor.rgb, noiseColor.rgb), inputColor.a);
    else if (blendMode == 4)
    {
        vec3 darkNoise = BlendColorBurn(noiseColor.rgb, vec3(0.5));
        vec3 noiseBlendCol = BlendOverlay(inputColor.rgb, noiseColor.rgb);
        float gray = dot(inputColor.rgb, vec3(0.299, 0.587, 0.114));
        noiseBlendCol = mix(noiseBlendCol, BlendScreen(noiseBlendCol, darkNoise), 0.5 * smoothstep(150. / 255., 130. / 255., gray));
        fgColor = vec4(noiseBlendCol, inputColor.a);
    }
    else if (blendMode == 5) fgColor = vec4(BlendDifference(inputColor.rgb, noiseColor.rgb), inputColor.a);
    else fgColor = vec4(BlendScreen(inputColor.rgb, noiseColor.rgb), inputColor.a);
    // gl_FragColor = fgColor; return;

    if (blendMode == 2)
    {
        fgColor.r = inputColor.r + fgColor.r * intensity * colorIntensity;//u_intensityR;
        fgColor.g = inputColor.g + fgColor.g * intensity * colorIntensity;//u_intensityG;
        fgColor.b = inputColor.b + fgColor.b * intensity * colorIntensity;//u_intensityB;
    }
    else
    {
        fgColor.r = mix(inputColor.r, fgColor.r, intensity * colorIntensity);//u_intensityR);
        fgColor.g = mix(inputColor.g, fgColor.g, intensity * colorIntensity);//u_intensityG);
        fgColor.b = mix(inputColor.b, fgColor.b, intensity * colorIntensity);//u_intensityB);
    }

    float aspectRatio = iResolution.y / iResolution.x;
    float borderWidth = u_borderWidth / iResolution.y;
    float outerMask = roundedRectMask(
    textureCoordinate, noiseCenter,
    noiseRange,
    min(min(
    u_radius,
    noiseRange.x / aspectRatio / 4.0),
    noiseRange.y / 4.0),
    aspectRatio, u_smoothing
    );
    float innerMask = roundedRectMask(
    textureCoordinate, noiseCenter,
    noiseRange - borderWidth * vec2(aspectRatio, 1.0),
    min(min(max(0.0, u_radius - borderWidth / 4.0), (noiseRange.x / aspectRatio - borderWidth) / 4.0), (noiseRange.y - borderWidth) / 4.0),
    aspectRatio, u_smoothing
    );
    float borderMask = outerMask - innerMask;

    vec4 finalColor = inputColor;
    if (borderMask > 0.0)
    {
        finalColor = vec4(borderMask * u_borderColor, 1.0);
    }
    if (innerMask > 0.0)
    {
        finalColor = innerMask * fgColor;
    }

    vec4 maskColor = texture2D(inputImageTexture3, textureCoordinate);
    float black = 45. / 255.;
    float smoothBlack = 152. / 255.;
    float white = 198. / 255.;
    float smoothWhite = 72. / 255.;
    float grey = maskColor.r;
    maskColor *= smoothstep(-smoothBlack, 0., grey - black);
    maskColor *= smoothstep(-smoothWhite, 0., white - grey);
    finalColor = mix(inputColor, finalColor, maskColor.a);
    gl_FragColor = finalColor;
    // gl_FragColor =texture2D(inputImageTexture, textureCoordinate);
    // gl_FragColor = vec4(noiseColor, 1.0);
}
