precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
//噪点纹理
uniform sampler2D inputImageTexture2;
//高光原始原始纹理
uniform sampler2D inputImageTexture3;
//取高光前的原始纹理
uniform sampler2D inputImageTexture4;

//高光mix强度
uniform float intensity;
//噪点强度
uniform float noiseIntensity;
uniform float noiseSize;
//高光强度
uniform float lightIntensity;

float blendScreen(float base, float blend) {
    return 1.0-((1.0-base)*(1.0-blend));
}

vec3 blendScreen(vec3 base, vec3 blend) {
    return vec3(blendScreen(base.r, blend.r), blendScreen(base.g, blend.g), blendScreen(base.b, blend.b));
}

vec4 addNoise(vec2 uv, vec4 color1, float dis){
    float strengthPower = 1.0*noiseSize;
    float strength = 16.0 * strengthPower;
    float x = (uv.x + 4.0) * (uv.y + 4.0) * ((mod(1.0, 100.0)+3.0)* 10.0);
    vec4 grain =vec4(mod((mod(x, 13.0) + 1.0) * (mod(x, 123.0) + 1.0), 0.01) - 0.005) *strength;
    //vec4 color1 = texture2D(inputImageTexture,uv);
    vec4 resultCol = color1 + grain * noiseSize*dis;
    //gl_FragColor = clamp(gl_FragColor, 0.0, gl_FragColor.a);
    return vec4(resultCol);
}

void main() {
    //模糊后纹理
    vec4 result = texture2D(inputImageTexture, textureCoordinate);

    vec4 baseColor = texture2D(inputImageTexture4,textureCoordinate);
    vec4 screenColor = lightIntensity*baseColor;

    vec4 resultCol = mix(baseColor,screenColor, result.r * intensity);
    //噪点纹理
    vec4 noiseCol = texture2D(inputImageTexture2, textureCoordinate);
    vec3 blendCol = blendScreen(noiseCol.rgb,resultCol.rgb);

    resultCol.rgb = mix(resultCol.rgb,blendCol,noiseIntensity);
    resultCol=addNoise(textureCoordinate,resultCol,noiseIntensity);

    gl_FragColor = resultCol;
    gl_FragColor.a = texture2D(inputImageTexture4,textureCoordinate).a;

}

