precision highp float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;

uniform float intensity;

vec4 realColor(sampler2D tex, vec2 kernal){
    vec4 n = texture2D(tex, kernal);
    n.rgb /= (n.a + 0.0001);
    return n;
}

void main() {

    vec4 resultColor = texture2D(inputImageTexture, textureCoordinate);
    vec3 refraction = vec3(1.0-0.05*intensity, 1.0, 1.0+0.05*intensity);

    vec2 distortionCoord[3];
    vec2 coord_map;
    //const vec2 center(0.0,0.0);

    coord_map[0] = textureCoordinate.x;
    coord_map[1] = textureCoordinate.y;
    distortionCoord[0][0] = refraction[0]*coord_map[0];
    //distortionCoord[0][1] = refraction[0]*coord_map[1];
    distortionCoord[0][1] = coord_map[1];
    distortionCoord[1][0] = refraction[1]*coord_map[0];
    //distortionCoord[1][1] = refraction[1]*coord_map[1];
    distortionCoord[1][1] = coord_map[1];
    distortionCoord[2][0] = refraction[2]*coord_map[0];
    //distortionCoord[2][1] = refraction[2]*coord_map[1];
    distortionCoord[2][1] = coord_map[1];

    resultColor.r = realColor(inputImageTexture,distortionCoord[0]).r;
    resultColor.g = realColor(inputImageTexture,distortionCoord[1]).g;
    resultColor.b = realColor(inputImageTexture,distortionCoord[2]).b;

    resultColor.rgb *= resultColor.a;
    gl_FragColor = resultColor;
}