precision highp float;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
varying vec2 textureCoordinate;

vec4 caculLut(vec4 inColor,sampler2D lut){
    highp float g = inColor.g * 16.0;
    highp float v = (0.5 / 17.0) + inColor.r * (1.0 - 1.0 / 17.0);
    highp float b = inColor.b * 16.0 / 17.0 + (0.5 / 17.0);
    highp float u1 = b / 17.0 + floor(g) / 17.0;
    highp float u2 = b / 17.0 + ceil(g) / 17.0;
    lowp vec4 newColor1 = texture2D(lut, vec2(u1, v));
    lowp vec4 newColor2 = texture2D(lut, vec2(u2, v));
    return mix(newColor1, newColor2, fract(g));
}

void main() {
    highp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor = caculLut(textureColor,inputImageTexture2);
}