precision highp float;
varying vec2 textureCoordinate;

uniform sampler2D inputImageTexture;

uniform vec2 iResolution;

uniform float amount;
uniform float passthrough;

vec4 edges()
{
    vec2 vUv=textureCoordinate;
    vec2 texel=vec2(1./512.);
    mat3 G[2];
    const mat3 g0=mat3(1., 2., 1., 0., 0., 0., -1., -2., -1.);
    const mat3 g1=mat3(1., 0., -1., 2., 0., -2., 1., 0., -1.);

    mat3 I;
    float cnv[2];
    vec3 sample2;
    G[0]=g0;
    G[1]=g1;
    for (int i=0;i<3;i++){
        for (int j=0;j<3;j++){
            sample2=texture2D(inputImageTexture, vUv+texel*vec2(i-1, j-1)).rgb;
            I[i][j]=length(sample2);
        }
    }
    for (int i=0;i<2;i++){
        float dp3=dot(G[i][0], I[0])+dot(G[i][1], I[1])+dot(G[i][2], I[2]);
        cnv[i]=dp3*dp3;
    }
    vec4 orig=texture2D(inputImageTexture, vUv);
    vec4 resultColor=orig*passthrough+vec4(.5*sqrt(cnv[0]*cnv[0]+cnv[1]*cnv[1]))*amount;

    resultColor.a = 1.0;
    return resultColor;
}

void main(void)
{
    vec2 screenSize=vec2(iResolution.x, iResolution.y);
    vec4 curColor=texture2D(inputImageTexture, textureCoordinate);
    vec4 resultColor=edges();

    resultColor.a = curColor.a;
    gl_FragColor=resultColor;
}
