precision highp float;
uniform vec4 color;
//uniform float colOffset;
// uniform
// Source texture
uniform sampler2D inputImageTexture;
// Edge texture
uniform sampler2D inputImageTexture2;
// The intensity of the source
uniform float edgeIntensity;
// Glow threshold
uniform float glowThreshold;
// The intensity of glow
uniform float glowIntensity;

// varying
// BlurUVs
varying highp vec2 textureCoordinate;

// Screen overlay  gray
float screen(float src, float dst) {
    return 1.0 - (1.0 - dst) * (1.0 - src);
}
// Screen overlay  RGB
vec4 screen(vec4 src, vec4 dst) {
    return vec4(
    screen(src.x, dst.x),
    screen(src.y, dst.y),
    screen(src.z, dst.z),
    screen(src.w, dst.w)
    );
}

void main() {
    // The sampling
    lowp vec4 base = texture2D(inputImageTexture, textureCoordinate);
    base.rgb /= (base.a + 0.0001);
    lowp vec4 edge = texture2D(inputImageTexture2, textureCoordinate)*vec4(color.rgb,1.0) * edgeIntensity;
    // Mixed external luminescence
    lowp vec4 edged = screen(edge, base);
    // glow
    lowp float gray = dot(base.rgb, vec3(0.299, 0.587, 0.114));
    lowp float bloom = max(0.0, gray - glowThreshold) * glowIntensity;
    // The return value
    gl_FragColor = vec4(edged.rgb * edged.a, base.a);
}