precision highp float;
varying vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
//bglut
uniform sampler2D inputImageTexture2;
//skinlut
uniform sampler2D inputImageTexture3;

uniform vec2 iResolution;

uniform float intensity;
uniform float mixIntensity;

vec4 lm_take_effect_filter(sampler2D filterTex, vec4 inputColor, float uniAlpha)
{
    highp vec4 textureColor= inputColor;//texture2D(inputTex,textureCoordinate);
    highp float blueColor=textureColor.b*63.;

    highp vec2 quad1;
    quad1.y=floor(floor(blueColor)/8.);
    quad1.x=floor(blueColor)-(quad1.y*8.);

    highp vec2 quad2;
    quad2.y=floor(ceil(blueColor)/8.);
    quad2.x=ceil(blueColor)-(quad2.y*8.);

    highp vec2 texPos1;
    texPos1.x=(quad1.x*1./8.)+.5/512.+((1./8.-1./512.)*textureColor.r);
    texPos1.y=(quad1.y*1./8.)+.5/512.+((1./8.-1./512.)*textureColor.g);

    highp vec2 texPos2;
    texPos2.x=(quad2.x*1./8.)+.5/512.+((1./8.-1./512.)*textureColor.r);
    texPos2.y=(quad2.y*1./8.)+.5/512.+((1./8.-1./512.)*textureColor.g);

    vec4 newColor1=texture2D(filterTex, texPos1);
    vec4 newColor2=texture2D(filterTex, texPos2);
    vec4 newColor=mix(newColor1, newColor2, fract(blueColor));
    newColor = mix(textureColor, vec4(newColor.rgb, textureColor.w), uniAlpha);

    return newColor;
}

float mask(vec4 base) {
    vec3 skin = vec3(0.76862745,0.59607843,0.48235294);
    bool redIn = base.r < skin.r+0.1 && base.r > skin.r -0.1;
    bool greenIn = base.g < skin.g+0.1 && base.g > skin.g -0.1;
    bool blurIn = base.b < skin.b+0.1 && base.b > skin.b -0.1;
    if (redIn && greenIn && blurIn) {
        return 1.0;
    } else {
        return 0.0;
    }
}

void main(void)
{
    //vec2 maskCoord = vec2(textureCoordinate.x, 1.0 - textureCoordinate.y);
    // vec2 screenSize = vec2(iResolution.x, iResolution.y);
    vec2 uv = textureCoordinate;
    vec4 color = texture2D(inputImageTexture, uv);
    // vec4 filter =  texture2D(inputImageTexture2, uv);
    vec4 bgResultColor = lm_take_effect_filter(inputImageTexture2, color, intensity);
    vec4 skinResultColor = lm_take_effect_filter(inputImageTexture3, color, intensity);
    vec4 resultColor = mix(bgResultColor, skinResultColor, mixIntensity);
    gl_FragColor = resultColor;
    gl_FragColor = clamp(gl_FragColor, 0.0, gl_FragColor.a);
}
