precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
//背景
uniform sampler2D inputImageTexture2;
//皮肤
uniform sampler2D inputImageTexture3;
uniform sampler2D maskTexture;

//强度0-1
uniform float intensity;
uniform float iResolution;

vec4 lutFilter(sampler2D filterTex,vec4 inputColor,float uniAlpha)
{
    highp vec4 textureColor= inputColor;	//texture2D(inputTex,textureCoordinate);
    highp float blueColor=textureColor.b*63.;

    highp vec2 quad1;
    quad1.y=floor(floor(blueColor)/8.);
    quad1.x=floor(blueColor)-(quad1.y*8.);

    highp vec2 quad2;
    quad2.y=floor(ceil(blueColor)/8.);
    quad2.x=ceil(blueColor)-(quad2.y*8.);

    highp vec2 texPos1;
    texPos1.x=(quad1.x*1./8.)+.5/512.+((1./8.-1./512.)*textureColor.r);
    texPos1.y=(quad1.y*1./8.)+.5/512.+((1./8.-1./512.)*textureColor.g);

    highp vec2 texPos2;
    texPos2.x=(quad2.x*1./8.)+.5/512.+((1./8.-1./512.)*textureColor.r);
    texPos2.y=(quad2.y*1./8.)+.5/512.+((1./8.-1./512.)*textureColor.g);

    vec4 newColor1=texture2D(filterTex,texPos1);
    vec4 newColor2=texture2D(filterTex,texPos2);
    vec4 newColor=mix(newColor1,newColor2,fract(blueColor));
    newColor = mix(textureColor,vec4(newColor.rgb,textureColor.w),uniAlpha);

    return newColor;
}
void main() {
    vec2 maskCoord = vec2(textureCoordinate.x, 1.0 - textureCoordinate.y);
    float mask = texture2D(maskTexture, maskCoord).a;
    // vec2 screenSize = vec2(iResolution.x, iResolution.y);
    vec4 color = texture2D(inputImageTexture, textureCoordinate);
    // vec4 filter =  texture2D(inputImageTexture2, textureCoordinate);
    vec4 bgResultColor = lutFilter(inputImageTexture2, color, intensity);
    vec4 skinResultColor = lutFilter(inputImageTexture3, color, intensity);
    vec4 resultColor = mix(bgResultColor, skinResultColor, mask);
    gl_FragColor = resultColor;
    gl_FragColor = clamp(gl_FragColor, 0.0, gl_FragColor.a);
}
