precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform vec2 iResolution;
uniform float intensity;

#define RESULT_14_DEVIDE_9     1.55556
#define RESULT_10_DEVIDE_9     1.11111
#define RESULT_8_DEVIDE_9      0.88889
#define RESULT_10_DEVIDE_16    0.625     
void main()
{

    lowp vec4 color1 = texture2D(inputImageTexture, textureCoordinate);

    //blend 
    lowp vec4 blendColor = color1;
    float aspectRatio = float(iResolution.y) / float(iResolution.x);

    if (aspectRatio > RESULT_14_DEVIDE_9) {
        blendColor = texture2D(inputImageTexture2, textureCoordinate);
    } else if (aspectRatio > RESULT_10_DEVIDE_9) {
        blendColor = texture2D(inputImageTexture2, textureCoordinate);
    } else if (aspectRatio > RESULT_8_DEVIDE_9) {
        blendColor = texture2D(inputImageTexture2, textureCoordinate);
    } else if (aspectRatio > RESULT_10_DEVIDE_16) {
        blendColor = texture2D(inputImageTexture2, textureCoordinate);
    } else {
        blendColor = texture2D(inputImageTexture2, textureCoordinate);
    }

    lowp vec4 resultColor = mix(color1, blendColor, blendColor.a * intensity);

    gl_FragColor = vec4(resultColor.rgb, color1.a);
    gl_FragColor = clamp(gl_FragColor, 0.0, gl_FragColor.a);
}

