precision mediump float;
vec2 seed;
varying vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float scale;
uniform float stepX;
uniform float stepY;
uniform float timestamp;
float rand(vec2 loc) {
    float theta1 = dot(loc, vec2(0.9898, 0.233));
    float theta2 = dot(loc, vec2(12.0, 78.0));
    float value = cos(theta1) * sin(theta2) + sin(theta1) * cos(theta2);
    float temp = mod(197.0 * value, 1.0) + value;
    float part1 = mod(220.0 * temp, 1.0) + temp;
    float part2 = value * 0.5453;
    float part3 = cos(theta1 + theta2) * 0.43758;
    float sum = (part1 + part2 + part3);
    return fract(sum)*scale;
}
void main() {
    seed[0] = 0.5;
    seed[1] = 0.5;
    float noise = texture2D(inputImageTexture2, textureCoordinate + vec2(-stepX, -stepY)).r * 0.224;
    noise += texture2D(inputImageTexture2, textureCoordinate+ vec2(-stepX, stepY)).r * 0.224;
    noise += texture2D(inputImageTexture2, textureCoordinate+ vec2(stepX, -stepY)).r * 0.224;
    noise += texture2D(inputImageTexture2, textureCoordinate+ vec2(stepX, stepY)).r * 0.224;
    noise += 0.4448;
    noise *= scale;
    vec4 color = texture2D(inputImageTexture, textureCoordinate);
    float energy = 0.33333 * color.r + 0.33333 * color.g + 0.33333 * color.b;
    float mask = (1.0 - sqrt(energy));
    float weight = 1.0 - 1.333 * mask * noise;
    gl_FragColor = vec4(color.rgb * weight, color.a);
    gl_FragColor = gl_FragColor + vec4(rand(textureCoordinate + seed), rand(textureCoordinate + seed), rand(textureCoordinate+ seed), 1);
}