precision mediump float;
uniform sampler2D inputImageTexture;// 输入的图片
varying vec2 textureCoordinate;

uniform float noise_density;// 噪点密度
uniform float distance_threshold;// 距离阈值
uniform float time;// 时间参数

float rand(vec2 n) {
    return fract(sin(dot(n, vec2(12.9898, 4.1414))) * 43758.5453);
}

float noise(vec2 p){
    vec2 ip = floor(p);
    vec2 u = fract(p);
    u = u*u*(3.0-2.0*u);

    float res = mix(
    mix(rand(ip), rand(ip+vec2(1.0, 0.0)), u.x),
    mix(rand(ip+vec2(0.0, 1.0)), rand(ip+vec2(1.0, 1.0)), u.x), u.y);
    return res*res;
}

void main()
{
    vec2 uv = textureCoordinate.xy;
    vec4 color = texture2D(inputImageTexture, textureCoordinate.xy);// 获取原始颜色
    color.rgb += noise(uv);// 在噪点范围内，添加噪点
    gl_FragColor = color;
}