#define OCTAVES 6 // 噪声图的层数
#define SCALE 2.0 // 缩放因子
precision mediump float;
varying vec2 textureCoordinate;
float rand(vec2 n) // 生成随机数函数
{
    return fract(sin(dot(n, vec2(12.9898, 4.1414))) * 43758.5453);
}

float noise(vec2 n) // 生成噪点函数
{
    vec2 i = floor(n);
    vec2 f = fract(n);

    vec2 u = f * f * (3.0 - 2.0 * f);
    float a = rand(i);
    float b = rand(i + vec2(1.0, 0.0));
    float c = rand(i + vec2(0.0, 1.0));
    float d = rand(i + vec2(1.0, 1.0));
    float x1 = mix(a, b, u.x);
    float x2 = mix(c, d, u.x);
    return mix(x1, x2, u.y);
}

float fbm(vec2 n) // 分形布朗运动函数
{
    float total = 0.0;
    float amplitude = 1.0;
    for (int i = 0; i < OCTAVES; i++) {
        total += noise(n * SCALE) * amplitude;
        n = n * 2.0;
        amplitude *= 0.5;
    }
    return total;
}

void main()
{
    vec2 uv = textureCoordinate.xy;
    vec4 color = vec4(0.0, 0.0, 0.0, 1.0);

    float n = fbm(uv);
    color.rgb = vec3(n);

    gl_FragColor = color;
}