precision highp float;

uniform sampler2D inputImageTexture; // 输入的图片
uniform float particle_density; // 颗粒密度
uniform float min_size; // 颗粒最小大小
uniform float max_size; // 颗粒最大大小
uniform float time; // 时间参数
varying vec2 textureCoordinate;
float rand(float n) // 生成随机数函数
{
    return fract(sin(n) * 43758.5453123);
}

float noise(vec2 n) // 生成噪点函数
{
    const vec2 d = vec2(0.0, 1.0);
    vec2 b = floor(n), f = smoothstep(vec2(0.0), vec2(1.0), fract(n));
    return mix(mix(rand(dot(b, d)), rand(dot(b + vec2(1.0, 0.0), d)), f.x),
    mix(rand(dot(b + vec2(0.0, 1.0), d)), rand(dot(b + vec2(1.0, 1.0), d)), f.x), f.y);
}

void main()
{
    vec2 uv = textureCoordinate.xy;
    vec4 color = texture2D(tex, uv); // 获取原始颜色
    float p = noise(vec2(uv * particle_density + time)) * (max_size - min_size) + min_size; // 计算随机颗粒大小
    float x = floor(uv.x * particle_density);
    float y = floor(uv.y * particle_density);
    float a = noise(vec2(x + time, y)); // 计算随机颗粒位置
    if (a < 0.1) {
        color.rgb += vec3(1.0) * p; // 在随机位置添加随机颗粒
    }
    gl_FragColor = color;
}