precision highp float;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
varying vec2 textureCoordinate;
uniform float u_noise;
vec3 rgb2gray = vec3(0.299, 0.587, 0.114);
float get_grain_texture(vec2 uv, float random_x, float random_y, float u_max, float v_max)
{
    vec2 res;
    float random_u = check_value(uv.x + random_x);
    float random_v = check_value(uv.y + random_y);

    res.x = check_value(random_u * u_max);
    res.y = check_value(random_v * v_max);
    return texture2D(inputImageTexture2, res).r;;
}
vec4 applyNoise(vec4 raw, float intensity) {
    vec3 new_color = raw.rgb;
    vec2 uv=v_uv;
    vec3 ori_color = raw.rgb;
    vec3 grain_color;
    float ori_gray = dot(rgb2gray, ori_color);
    ori_gray = ori_gray * 2.0 - 1.0;
    float abs_ori_gray = abs(ori_gray);
    float abs_ori_gray2 = abs_ori_gray * abs_ori_gray;
    float abs_ori_gray3 = abs_ori_gray2 * abs_ori_gray;
    float grain_gray = get_grain_texture(uv, random_x1, random_y1, u_max, v_max);
    grain_gray = grain_gray * 2.0 - 1.0;
    float mask;
    float strength = 0.49019608;
    if (ori_gray >= 0.)
    {
        mask = (abs_ori_gray3 * 0.5 + abs_ori_gray2 * 0.5) * (strength - 0.03921569);
    }
    else
    {
        mask = (abs_ori_gray2 * 0.4 + abs_ori_gray * 0.6) * strength;
    }
    new_color = clamp(ori_color + grain_gray * (strength - mask), 0., 1.);
    new_color = mix(ori_color.rgb, new_color, intensity);
    return vec4(new_color, raw.a);
    // return vec4(raw);
}

void main() {
    vec4 base = texture2D(inputImageTexture, textureCoordinate);
    vec4 color = base;
    color = applyNoise(color, u_noise);
    gl_FragColor = vec4(color.rgb * base.a, base.a);
}